TRAININGGROUNDS_CombatModule_Tutorial_W7_WindwalkerMonk = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_CombatModule)

function TRAININGGROUNDS_CombatModule_Tutorial_W7_WindwalkerMonk:setup(character)
	TRAININGGROUNDS_CombatModule.setup(self,character)
	
end


function TRAININGGROUNDS_CombatModule_Tutorial_W7_WindwalkerMonk:SetResources()
		
	self.showtargetcircles=true
		
	self.scktargets={}		
		
	self.hastepercent=0
	--self.hastepercent=0.15
	--self.hastepercent=0.20
	--self.hastepercent=0.30
	--self.hastepercent=0.50
		
	-- set up resources before applying spells.
	-- spells will link back to these resources
	
	self.energy=TRAININGGROUNDS_Resource.new()
	-- -- "energyregenrate" is a local temp; what matters is what we plug into energy:setup
	--local energyregenrate=11.1	--TODO: calculate from haste
	
	local energyregenrate=10.0*(1+self.hastepercent)
	--local energyregenrate=10.0*(1+0.5)	--!!!
	self.energy:setup(self,"energy",0,130,130,energyregenrate*1.15)
	self.energy.visibleinnameplate=false
	self.energy.displaycolor={1,1,0,1}	
	tinsert(self.resources,self.energy)
	
		
	self.chi=TRAININGGROUNDS_Resource.new()
	self.chi:setup(self,"chi",0,6,0,0)
	self.chi.visibleinnameplate=false
	self.chi.displaycolor={0.9,0.9,0.9,1}
	self.chi.displaystyle=TRAININGGROUNDS_Resource.DISPLAYSTYLE_CIRCLE
	tinsert(self.resources,self.chi)
	
end

function TRAININGGROUNDS_CombatModule_Tutorial_W7_WindwalkerMonk:SetSpells()
		
		
	-------------------------------------------------------------------------------
	
	self.critterattack=TRAININGGROUNDS_Spell_Tutorial_CritterAttack.new()
	self.critterattack:setup(self)
	tinsert(self.spellbook,self.critterattack)	
	

	self.tigerpalm=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_TigerPalm.new()
	self.tigerpalm:setup(self)
	tinsert(self.spellbook,self.tigerpalm)	


	self.fistsoffury=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_FistsOfFury.new()
	self.fistsoffury:setup(self)
	tinsert(self.spellbook,self.fistsoffury)	


	self.strikeofthewindlord=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_StrikeOfTheWindlord.new()
	self.strikeofthewindlord:setup(self)
	tinsert(self.spellbook,self.strikeofthewindlord)	


	self.risingsunkick=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_RisingSunKick.new()
	self.risingsunkick:setup(self)
	tinsert(self.spellbook,self.risingsunkick)	


	self.blackoutkick=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_BlackoutKick.new()
	self.blackoutkick:setup(self)
	tinsert(self.spellbook,self.blackoutkick)	

	self.fakecombobreakerblackoutkick=TRAININGGROUNDS_FakeSpell_W7_WindwalkerMonk_ComboBreakerBlackoutKick.new()
	self.fakecombobreakerblackoutkick:setup(self)
	tinsert(self.spellbook,self.fakecombobreakerblackoutkick)
		

	self.spinningcranekick=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_SpinningCraneKick.new()
	self.spinningcranekick:setup(self)
	tinsert(self.spellbook,self.spinningcranekick)	

	self.tigereyebrew=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_TigereyeBrew.new()
	self.tigereyebrew:setup(self)
	tinsert(self.spellbook,self.tigereyebrew)			
	
	self.touchofdeath=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_TouchOfDeath.new()
	self.touchofdeath:setup(self)
	tinsert(self.spellbook,self.touchofdeath)
	
		
	self.speedboost=TRAININGGROUNDS_Spell_Tutorial_SpeedBoost.new()
	self.speedboost:setup(self)
	tinsert(self.spellbook,self.speedboost)
	
	self.tutorialroll=TRAININGGROUNDS_Spell_Tutorial_Roll.new()
	self.tutorialroll:setup(self)
	tinsert(self.spellbook,self.tutorialroll)
	
	self.tigerslust=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_TigersLust.new()
	self.tigerslust:setup(self)
	tinsert(self.spellbook,self.tigerslust)

	self.roll=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_Roll.new()
	self.roll:setup(self)
	tinsert(self.spellbook,self.roll)
	
	self.flyingserpentkick=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_FlyingSerpentKick.new()
	self.flyingserpentkick:setup(self)
	tinsert(self.spellbook,self.flyingserpentkick)	
		
	-------------------------------------------------------------------------------
	
	--TODO: move to base CombatModule
	self.gcdtracker=TRAININGGROUNDS_FakeSpell_GCDTracker.new()
	self.gcdtracker:setup(self)
	tinsert(self.spellbook,self.gcdtracker)
	

	
end



function TRAININGGROUNDS_CombatModule_Tutorial_W7_WindwalkerMonk:CreateSpellButtons()
	--print("CreateSpellButtons")

	self:CreateActionBar()
	
	local spellbutton
	
	spellbutton=TRAININGGROUNDS_SpellButton.new()
	spellbutton:setup(self.tigerpalm,self.actionbar,"1",false,false)
	tinsert(self.spellbuttons,spellbutton)

	spellbutton=TRAININGGROUNDS_SpellButton.new()
	spellbutton:setup(self.fistsoffury,self.actionbar,"2",false,false)
	tinsert(self.spellbuttons,spellbutton)
	
	spellbutton=TRAININGGROUNDS_SpellButton.new()
	spellbutton:setup(self.strikeofthewindlord,self.actionbar,"2",true,false)
	tinsert(self.spellbuttons,spellbutton)
	
	spellbutton=TRAININGGROUNDS_SpellButton.new()
	spellbutton:setup(self.risingsunkick,self.actionbar,"3",false,false)
	tinsert(self.spellbuttons,spellbutton)
		
	spellbutton=TRAININGGROUNDS_SpellButton.new()
	spellbutton:setup(self.blackoutkick,self.actionbar,"4",false,false)
	tinsert(self.spellbuttons,spellbutton)

	spellbutton=TRAININGGROUNDS_SpellButton.new()
	spellbutton:setup(self.spinningcranekick,self.actionbar,"4",true,false)
	tinsert(self.spellbuttons,spellbutton)		

	spellbutton=TRAININGGROUNDS_SpellButton.new()
	spellbutton:setup(self.tigereyebrew,self.actionbar,"6",false,false)
	tinsert(self.spellbuttons,spellbutton)	

	spellbutton=TRAININGGROUNDS_SpellButton.new()
	spellbutton:setup(self.touchofdeath,self.actionbar,"7",false,false)
	tinsert(self.spellbuttons,spellbutton)		
	
	
	
	
	--TODO: move to CombatModule
	if(_TRAININGGROUNDS.debug_debugwindow==true)then
		local i
		for i=1,#self.spellbook,1 do
			local spell=self.spellbook[i]
			if(spell.visibletostatistics==true)then
				local f=TRAININGGROUNDS_ReusableFrames.getFrame()
										--TODO: not _TRAININGGROUNDS
				f.fontstring:SetParent(_TRAININGGROUNDS.game.debugwindow.environment_ui.frame)
				f.fontstring:SetPoint("TOPLEFT",_TRAININGGROUNDS.game.debugwindow.environment_ui.frame,"TOPLEFT",5,(i*-20)+5)
				
				f:SetFrameLevel(255)
				f:SetWidth(TRAININGGROUNDS_DebugWindow.SCREENWIDTH)
				f:SetHeight(20)
				f.fontstring:SetText(spell.shortspellname..": 0")
				f.fontstring:Show()			
				f:Show()
				tinsert(self.debugspelltexts,f)
				
				spell.usecounttextbox=f
			end
		end
	end
	
end

function TRAININGGROUNDS_CombatModule_Tutorial_W7_WindwalkerMonk:CreateTutorialSpellButtons(level)
	self:ClearAllSpellButtons()
	self:CreateActionBar()
	
	local spellbutton
	
--TODO: tutorial speedboost+roll icons?
	-- (might not necessarily need to be visible, but still need to set up button keyinputs)
	
	if(level==1)then
		--do nothing
		return
	end
	if(level==2)then		
		spellbutton=TRAININGGROUNDS_SpellButton.new()
		spellbutton:setup(self.critterattack,self.actionbar,"1",false,false)
		tinsert(self.spellbuttons,spellbutton)		
		--print(spellbutton.frame,spellbutton.frame.framelevel,spellbutton.frame.cooldown,spellbutton.frame.cooldown.framelevel,spellbutton.charges,spellbutton.charges.framelevel)
		--ActionButton_ShowOverlayGlow(spellbutton.frame)
		return
	end
	
	if(level==3)then
		spellbutton=TRAININGGROUNDS_SpellButton.new();	spellbutton:setup(self.critterattack,self.actionbar,"1",false,false)
		tinsert(self.spellbuttons,spellbutton)
		
		spellbutton=TRAININGGROUNDS_SpellButton.new()
		spellbutton:setup(self.tutorialroll,self.actionbar,"8",false,false)		
		tinsert(self.spellbuttons,spellbutton)
		
		spellbutton=TRAININGGROUNDS_SpellButton.new()
		spellbutton:setup(self.speedboost,self.actionbar,"8",true,false)
		spellbutton.key="R";spellbutton.shift=false
		tinsert(self.spellbuttons,spellbutton)		
		
	end	
	if(level==4)then
		--do nothing
		return
	end
	
		
	--tiger palm
	if(level>=5)then		
		spellbutton=TRAININGGROUNDS_SpellButton.new()
		spellbutton:setup(self.tigerpalm,self.actionbar,"1",false,false)
		tinsert(self.spellbuttons,spellbutton)

		spellbutton=TRAININGGROUNDS_SpellButton.new()
		spellbutton:setup(self.roll,self.actionbar,"8",false,false)		
		tinsert(self.spellbuttons,spellbutton)
		
		spellbutton=TRAININGGROUNDS_SpellButton.new()
		spellbutton:setup(self.tigerslust,self.actionbar,"8",true,false)
		spellbutton.key="R";spellbutton.shift=false
		tinsert(self.spellbuttons,spellbutton)		

		if(level==5)then 
			self.energy.visibleinnameplate=true
			self.chi.visibleinnameplate=true
			self.energy.value=0
			self:CreateNameplate()
			self:CreateVisibleFrames()	-- cast+channel bar
			--self:CreateVisibleFrames() 
		end
		--if(level==5)then ActionButton_ShowOverlayGlow(spellbutton.frame) end
	end
	
	if(level>=6)then
		spellbutton=TRAININGGROUNDS_SpellButton.new()
		spellbutton:setup(self.fistsoffury,self.actionbar,"2",false,false)
		tinsert(self.spellbuttons,spellbutton)
	end
	
	if(level>=7)then
		spellbutton=TRAININGGROUNDS_SpellButton.new()
		spellbutton:setup(self.strikeofthewindlord,self.actionbar,"1",true,false)
		tinsert(self.spellbuttons,spellbutton)
	end	
	
	if(level>=8)then
		spellbutton=TRAININGGROUNDS_SpellButton.new()
		spellbutton:setup(self.risingsunkick,self.actionbar,"3",false,false)
		tinsert(self.spellbuttons,spellbutton)		
	end		

	if(level>=9)then
		spellbutton=TRAININGGROUNDS_SpellButton.new()
		spellbutton:setup(self.blackoutkick,self.actionbar,"4",false,false)
		tinsert(self.spellbuttons,spellbutton)		
	end			

	if(level>=10)then
		spellbutton=TRAININGGROUNDS_SpellButton.new()
		spellbutton:setup(self.spinningcranekick,self.actionbar,"4",true,false)
		tinsert(self.spellbuttons,spellbutton)		
	end

	if(level>=11)then
		spellbutton=TRAININGGROUNDS_SpellButton.new()
		spellbutton:setup(self.tigereyebrew,self.actionbar,"6",false,false)
		tinsert(self.spellbuttons,spellbutton)		
	end	
	
	if(level>=12)then
		spellbutton=TRAININGGROUNDS_SpellButton.new()
		spellbutton:setup(self.flyingserpentkick,self.actionbar,"9",false,false)
		tinsert(self.spellbuttons,spellbutton)		
	end		

	if(level>=13)then
		spellbutton=TRAININGGROUNDS_SpellButton.new()
		spellbutton:setup(self.touchofdeath,self.actionbar,"7",false,false)
		tinsert(self.spellbuttons,spellbutton)		
	end		

	
	--TODO: clear Combo Breaker buffs before enabling Blackout Kick
	
	--TODO: drawallcooldowns in parent function
	self:DrawAllCooldowns(self.character.environment.currenttime)
end







function TRAININGGROUNDS_CombatModule_Tutorial_W7_WindwalkerMonk:SetSCKTarget(target,impacttime)
	self.scktargets[tostring(target)]=impacttime
end

function TRAININGGROUNDS_CombatModule_Tutorial_W7_WindwalkerMonk:GetSCKTargetList()
	return self.scktargets
end


function TRAININGGROUNDS_CombatModule_Tutorial_W7_WindwalkerMonk:SetTTPMultiplierForSpell(spell)
	spell.ttpmultiplier=1
	local ttp=self:GetBuffIfExists(TRAININGGROUNDS_Buff_W7_WindwalkerMonk_TransferThePower)
	if(ttp~=nil)then
		spell.ttpmultiplier=spell.ttpmultiplier+0.05*ttp.stacks
		ttp:SelfDispel()
	end
end