TRAININGGROUNDS_ResourceDisplay = {}
TRAININGGROUNDS_ResourceDisplay.__index = TRAININGGROUNDS_ResourceDisplay

function TRAININGGROUNDS_ResourceDisplay:new()
	local self={}
	setmetatable(self, TRAININGGROUNDS_ResourceDisplay)	
	
	return self
end

function TRAININGGROUNDS_ResourceDisplay:setup(nameplate,resource)

	--if(self.value==nil)then self.value=resource.value end
	--if(self.max==nil)then self.max=resource.max end
	if(self.x==nil)then self.x=1 end
	if(self.wid==nil)then self.wid=100 end

	self.nameplate=nameplate
	self.resource=resource
	
	self.usefill2=false

	--TODO: change nameplate color depending on faction
	self.border=TRAININGGROUNDS_ReusableFrames.getFrame()	
	self.border:SetParent(nameplate.character.environment.frame)
	self.border.framelevel=nameplate.frame.framelevel+1
	self.border:SetFrameLevel(self.border.framelevel)
	self.border.texture:SetTexture(1,1,1,1)
	
	self.back=TRAININGGROUNDS_ReusableFrames.getFrame()	
	self.back:SetParent(nameplate.character.environment.frame)
	self.back.framelevel=nameplate.frame.framelevel+2
	self.back:SetFrameLevel(self.back.framelevel)
	self.back.texture:SetTexture(0,0,0,1)
	
	self.fill=TRAININGGROUNDS_ReusableFrames.getFrame()	
	self.fill:SetParent(nameplate.character.environment.frame)
	self.fill.framelevel=nameplate.frame.framelevel+3
	self.fill:SetFrameLevel(self.fill.framelevel)
	--self.fill.texture:SetTexture(1,0,0,1)
	self.fill.texture:SetTexture(unpack(self.resource.displaycolor))
	
	self.fill2=TRAININGGROUNDS_ReusableFrames.getFrame()	
	self.fill2:SetParent(nameplate.character.environment.frame)
	self.fill2.framelevel=nameplate.frame.framelevel+3
	self.fill2:SetFrameLevel(self.fill2.framelevel)
	self.fill2.texture:SetTexture(unpack(self.resource.displaycolor2))
	
	self.hurt=TRAININGGROUNDS_ReusableFrames.getFrame()	
	self.hurt:SetParent(nameplate.character.environment.frame)
	self.hurt.framelevel=nameplate.frame.framelevel+3
	self.hurt:SetFrameLevel(self.hurt.framelevel)
	self.hurt.texture:SetTexture(.75,.75,0,1)

	--print("TRAININGGROUNDS_Nameplate:setup "..self.border.framelevel.." , "..self.fill.framelevel)
		
	self.border:Show()	
	self.border.texture:Show()	
	self.back:Show()	
	self.back.texture:Show()	
	self.fill:Show()	
	self.fill.texture:Show()
	self.fill2:Hide()	
	self.fill2.texture:Show()
	self.hurt:Hide()
	self.hurt.texture:Hide()
end

function TRAININGGROUNDS_ResourceDisplay:SetPointsAndSizes(a,b,c,d,e,wid,hgt)
	--TODO: ask for fillheight, and maybe subtract -1 instead of -2 if zoomed out
	--self.x=d
	local visibleborder=true
	local fillwidth=self:GetFillWidth(wid)
	
	
	-- self.usefill2=true--!!!
	-- self.resource.fill2value=500	--!!!
	
	local fill2width=0
	if(self.resource.usefill2==true)then 
		fill2width=self:GetFill2Width(wid)-4
		if(fill2width<1)then fill2width=1 end
		--TODO: only subtract for appropriate effects (i.e. heal absorb, but not incoming heal)
		fillwidth=fillwidth-fill2width
	end

	fillwidth=fillwidth-4
	
	--if(fillwidth<1)then if(_TRAININGGROUNDS.game.keys.ctrl.current==true)then  error(1) end end
	--if(fillwidth<1)then if(_TRAININGGROUNDS.game.keys.ctrl.current==true)then print("wid==",wid) end end	
	
	-- -- if width<=0, the fill just bugs out and doesn't update at all
	-- -- TODO: hide fill when resources<=0		
	--if(fillwidth<1) then fillwidth=1 end
	--if(fillwidth<0.1) then fillwidth=0.1 end
	if(fillwidth<1) then 
		self.fill:Hide()
		fillwidth=0
		--print("!")
		-- self.fill.Show=function(self)
			-- error()
		-- end
	else
		--TODO: better visibility check
		if(self.resource.visibleinnameplate==true)then			
			self.fill:Show()
		end
	end
	
	local fillheight=hgt-4
	if(fillheight<2)then fillheight=2;visibleborder=false end

	--!!!
	self.border:ClearAllPoints()
	self.back:ClearAllPoints()
	self.fill:ClearAllPoints()
	self.fill2:ClearAllPoints()
	self.hurt:ClearAllPoints()

	
	
	self.border:SetPoint(a,b,c,d,e)
	self.back:SetPoint(a,b,c,d,e-2)
	--print(wid,fillwidth,fill2width,fillwidth+fill2width)
	local adjustedfillx=2+d-wid/2+fillwidth/2
	self.fill:SetPoint(a,b,c,adjustedfillx,e-2)	-- if zoomed out, 1+d instead of 2+d
	local adjustedfill2x=2+d-wid/2+fillwidth+fill2width/2
	self.fill2:SetPoint(a,b,c,adjustedfill2x,e-2)	-- if zoomed out, 1+d instead of 2+d	
	self.hurt:SetPoint(a,b,c,d,e-2)	
	
	

	--fillwidth=wid	
	
	self.border:SetWidth(wid);self.border:SetHeight(hgt)
	self.back:SetWidth(wid-4);self.back:SetHeight(fillheight)
	self.fill:SetWidth(fillwidth);self.fill:SetHeight(fillheight)
	self.fill2:SetWidth(fill2width);self.fill2:SetHeight(fillheight)
	self.hurt:SetWidth(wid-4);self.hurt:SetHeight(fillheight)
	
	if(self.resource.usefill2==true and self.resource.visibleinnameplate==true)then		
		--print("fill2 ",adjustedfillx,adjustedfill2x,self.resource.fill2value,fill2width)
		self.fill2:Show()		
	else
		self.fill2:Hide()
	end
	
	if(visibleborder==true)then
		self.border:Show()
	else
		self.border:Hide()
	end
end

-- function TRAININGGROUNDS_ResourceDisplay:SetSizes(wid,hgt)
	-- local fillheight=hgt-4
	-- if(fillheight<5)then fillheight=5 end

	-- self.wid=wid
	-- local fillwidth=self:GetFillWidth()
	-- if(fillwidth<5) then fillwidth=5 end
	-- --fillwidth=wid	
	
	-- self.border:SetWidth(wid);self.border:SetHeight(hgt)
	-- self.back:SetWidth(wid-4);self.back:SetHeight(fillheight)
	-- self.fill:SetWidth(fillwidth-4);self.fill:SetHeight(fillheight)
	-- self.hurt:SetWidth(wid-4);self.hurt:SetHeight(fillheight)
	
-- end

function TRAININGGROUNDS_ResourceDisplay:SetFrameLevels(layer)
	self.border:SetFrameLevel(layer)
	self.back:SetFrameLevel(layer+1)
	self.fill:SetFrameLevel(layer+2)
	self.fill2:SetFrameLevel(layer+2)
	self.hurt:SetFrameLevel(layer+2)
end

-- Does not include -4 for visible border.
function TRAININGGROUNDS_ResourceDisplay:GetFillWidth(wid)
	local fraction
	-- print(self)
	-- print(self.max)
	-- print(self.value)
	if(self.resource.max<=0)then
		fraction=0
	else
		fraction=self.resource.value/self.resource.max
	end
	if(fraction>1)then fraction=1 end
	
	return fraction*wid	
end

-- Does not include -4 for visible border.
function TRAININGGROUNDS_ResourceDisplay:GetFill2Width(wid)
	local fraction
	if(self.resource.fill2value<=0)then
		fraction=0
	else
		fraction=self.resource.fill2value/self.resource.max
	end
	if(fraction>1)then fraction=1 end
	
	return fraction*wid	
end

function TRAININGGROUNDS_ResourceDisplay:step(elapsed)
	--override
end

function TRAININGGROUNDS_ResourceDisplay:ShowAll()
	self.back:Show()
	self.fill:Show()
	if(self.resource.usefill2==true)then
		self.fill2:Show()
	end
	self.hurt:Show()
	--TODO: "visibleborder" is undefined!
	if(visibleborder==true)then
		self.border:Show()
	end
end

function TRAININGGROUNDS_ResourceDisplay:HideAll()
	self.border:Hide()
	self.back:Hide()
	self.fill:Hide()
	self.fill2:Cleanup()
	self.hurt:Hide()
end


function TRAININGGROUNDS_ResourceDisplay:Cleanup()
	self.border:Cleanup()
	self.back:Cleanup()
	self.fill:Cleanup()
	self.fill2:Cleanup()
	self.hurt:Cleanup()
end

