TRAININGGROUNDS_Spell_W7_WindwalkerMonk_ChiBurst = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_Spell)

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_ChiBurst:setCustomSpellInfo(combat)
	TRAININGGROUNDS_Spell.setCustomSpellInfo(self,combat)
	
	self.spellname="Chi Burst"
	self.shortspellname="CB"
	
	-- self.animationsequence=680
	-- self.animationlength=1000
	self.animationname="ChiBurst"
	
	self.defaultcooldown=30000
	
	self.casted=true
	self.casttime=1000
	self.castablewhilemoving=false
	
	self.damage=nil
	self.aoedamage=275
	
	self.range=nil
	-- Chi Burst projectile travels "40 yards"
	self.fakerange=800
	
	self.requirestarget=false
	
	self.procscombostrikes=true
	
	
	self.icon="Interface\\Icons\\spell_arcane_arcanetorrent"
end

--TODO: this will break as soon as we make any sort of change to parent function
function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_ChiBurst:RangeIsOkay(character,target)
	if(target==nil)then
		return TRAININGGROUNDS_SpellSuccessOrFailureResult_quicknew(true,nil)
	end
	local distance=character:HitboxDistanceFromOtherObject(target)
	if(distance>self.fakerange)then	
		return TRAININGGROUNDS_SpellSuccessOrFailureResult_quicknew(false,"Out of range.")
	end
	return TRAININGGROUNDS_SpellSuccessOrFailureResult_quicknew(true,nil)	
end

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_ChiBurst:OnCastStart(starttime)
	TRAININGGROUNDS_Spell.OnCastStart(self,starttime)
	self.combat.character:SetAnimationByName(self.animationname)
	self.combat.character.animationnextpriority=TRAININGGROUNDS_PlayerAnimations.PRIORITIES.EMOTE
	self.combat.character.animationchangeprioritytick=starttime+100

	--CB doesn't require facing, but if player has a target, snap to it
	if(self.combat.target~=nil)then
		self.combat.character.snapfacingtarget=self.combat.target
		--TODO: not "500"
		self.combat.character.snapfacingendtick=starttime+500
	end
end

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_ChiBurst:ApplySpellAnimation(executespelltick)
	-- do nothing; CB spell animation starts on cast start
end

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_ChiBurst:ApplyExecutedSpellSideEffects(executespelltick)
	TRAININGGROUNDS_Spell.ApplyExecutedSpellSideEffects(self,combat)
	local projectile=TRAININGGROUNDS_Particle_ChiBurst.new()
	projectile:setup(self.combat.character.environment)
	projectile.x=self.combat.character.x
	projectile.y=self.combat.character.y
	projectile.z=30
	projectile.gravity=0
	local speed=875	
	projectile.xspeed=speed*math.cos(self.combat.character.currentfacing-math.pi/2)
	projectile.yspeed=speed*math.sin(self.combat.character.currentfacing-math.pi/2)
	projectile.x=projectile.x+projectile.xspeed*.1
	projectile.y=projectile.y+projectile.yspeed*.1
	projectile.xstart=projectile.x
	projectile.ystart=projectile.y
	projectile.cangooob=true
	projectile.spell=self
end

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_ChiBurst:OnProjectileHit(tick,enemy)
	self.combat:ApplyDamageToEnemy(self.aoedamage,enemy,self)
end