TRAININGGROUNDS_Spell_W7_WindwalkerMonk_RushingJadeWind = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_Spell)

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_RushingJadeWind:setCustomSpellInfo(combat)
	TRAININGGROUNDS_Spell.setCustomSpellInfo(self,combat)
	
	--TODO: RJW grants RJW buff when used
	
	self.spellname="Rushing Jade Wind"
	self.shortspellname="RJW"
	
	self.animationlength=1000
	self.animationsequence=660
	--self.animationname="SpinningCraneKick"
	
	self.resource=combat.chi
	self.resourcecost=1
	self.defaultcooldown=6000	
	
	self.damage=nil
	self.aoedamage=60
	
	self.procscombostrikes=true
	
	self.icon="Interface\\Icons\\ability_monk_rushingjadewind"
end

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_RushingJadeWind:haveResources()
	if(self.combat:GetBuffIfExists(TRAININGGROUNDS_Buff_W7_WindwalkerMonk_Serenity)~=nil)then
		return TRAININGGROUNDS_SpellSuccessOrFailureResult_quicknew(true,nil)
	end
	return TRAININGGROUNDS_Spell.haveResources(self)	
end

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_RushingJadeWind:deductResourceCost()
	if(self.combat:GetBuffIfExists(TRAININGGROUNDS_Buff_W7_WindwalkerMonk_Serenity)~=nil)then
		return
	else
		TRAININGGROUNDS_Spell.deductResourceCost(self)
	end
end

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_RushingJadeWind:GetRechargeForUse()
	return self:GetCooldownForUse()
end

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_RushingJadeWind:GetCooldownForUse()
	local hastecooldown=floor(self.defaultcooldown*self.combat:GetHasteCastReductionMultiplier())
	if(self.combat:GetBuffIfExists(TRAININGGROUNDS_Buff_W7_WindwalkerMonk_Serenity)~=nil) then
		return hastecooldown/2
	else
		return hastecooldown
	end
end

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_RushingJadeWind:ApplyExecutedSpellSideEffects(executespelltick)	
	TRAININGGROUNDS_Spell.ApplyExecutedSpellSideEffects(self,combat)
	
	--TODO:
	self.combat.character:SetAnimationByIndex(self.animationsequence,TRAININGGROUNDS_PlayerAnimations.PRIORITIES.ATTACK,self.animationlength)
	
	--TODO: apply buff and move damage effects to that buff	
	local rjwbuff=TRAININGGROUNDS_Buff_W7_WindwalkerMonk_RushingJadeWind.new()		
	rjwbuff:setup(self.combat,executespelltick)
	rjwbuff.spell=self
	rjwbuff:CalculateDurationAndTickTime()
	
	
	for i=1,9,1 do
		-- local queuetime=self:GetRechargeForUse()/9*i
		-- self.combat:QueueImpact(executespelltick+queuetime, 
		-- function(tick)
			-- local minradius=1
			-- --local maxradius=350
			-- local maxradius=300
			
			-- local objlist=self.combat.character.environment:PointCircleCollisionList(self.combat.character.x, self.combat.character.y, minradius, maxradius)
			-- local wowlist={}
			-- local i
			-- for i=1,#objlist,1 do
				-- local obj=objlist[i]
				-- if(obj.combat~=nil)then
					-- --TODO: not isa
					-- if(obj:isa(TRAININGGROUNDS_Enemy))then		
						-- tinsert(wowlist,obj)
					-- end
				-- end
			-- end
			
			
			-- for i=1,#wowlist,1 do		
				-- local obj=wowlist[i]
				-- self.combat:ApplyDamageToEnemy(self.aoedamage,obj)			
			-- end
		-- end)
	end
	
end
