TRAININGGROUNDS_Spell_W7_WindwalkerMonk_SpinningDragonStrike = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_Spell)

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_SpinningDragonStrike:setCustomSpellInfo(combat)
	TRAININGGROUNDS_Spell.setCustomSpellInfo(self,combat)
	
	self.spellname="Whirling Dragon Punch"
	self.shortspellname="WDP"
	
	self.animationlength=1000
	self.animationsequence=660
	
	self.defaultcooldown=24000
	
	self.damage=nil
	self.aoedamage=360
	
	self.rskoffcooldowntick=0
	self.fofoffcooldowntick=0
	
	self.procscombostrikes=true
	
	self.icon="Interface\\Icons\\ability_monk_hurricanestrike"
end

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_SpinningDragonStrike:haveResources()
	--TODO: pass spell execution tick to function instead of asking for currenttime
	local mytick=self.combat.character.environment.currenttime
	if(self.offcooldowntick>mytick)then
		mytick=self.offcooldowntick
	end
	--if(self.combat.risingsunkick.offcooldowntick==nil)then return false end
	--if(self.combat.fistsoffury.offcooldowntick==nil)then return false end
	
	--if(mytick<self.rskoffcooldowntick
		--and mytick<self.fofoffcooldowntick)then
	if(self.combat.fistsoffury.naturaloffcooldowntick>mytick
		and self.combat.risingsunkick.naturaloffcooldowntick>mytick)then
		return TRAININGGROUNDS_SpellSuccessOrFailureResult_quicknew(true,nil)
	end
	return TRAININGGROUNDS_SpellSuccessOrFailureResult_quicknew(false,"You can't use that yet")
end


function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_SpinningDragonStrike:ApplySpellAnimation(executespelltime)
	TRAININGGROUNDS_Spell.ApplySpellAnimation(self,executespelltime)
	local env=self.combat.character.environment
	-- for i=1,#env.wowcharacters,1 do
		-- local ch=env.wowcharacters[i]
		
		-- if(ch~=self.combat.character)then
			-- ch.attackanimation=8
			-- ch.attackanimationendtick=executespelltime+750
			-- ch:changeFrameAnimation(ch.attackanimation)
		-- end
	-- end
end

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_SpinningDragonStrike:GetCooldownForUse()
	local hastecooldown=floor(self.defaultcooldown*self.combat:GetHasteCastReductionMultiplier())
	return hastecooldown	
end

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_SpinningDragonStrike:GetRechargeForUse()
	return self:GetCooldownForUse()
end

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_SpinningDragonStrike:ApplyExecutedSpellSideEffects(executespelltick)	
	TRAININGGROUNDS_Spell.ApplyExecutedSpellSideEffects(self,combat)
	
	--TODO:	
	self.combat.character:SetAnimationByIndex(self.animationsequence,TRAININGGROUNDS_PlayerAnimations.PRIORITIES.ATTACK,900)
	
	local buff=TRAININGGROUNDS_Buff_W7_WindwalkerMonk_WhirlingDragonPunch.new()
	buff:setup(self.combat,executespelltick)
	
	--TODO: apply buff and move damage effects to that buff	
	--TODO: keep player in air for buff
	--local attacktime=750
	local attacktime=500
	for i=1,3,1 do
		--local queuetime=attacktime/3*i
		local queuetime=attacktime/2*(i-1)
		self.combat:QueueImpact(executespelltick+queuetime, 
		function(tick)
			local minradius=1
			--local maxradius=350
			local maxradius=300
			
			local objlist=self.combat.character.environment:PointCircleCollisionList(self.combat.character.x, self.combat.character.y, minradius, maxradius)
			local wowlist={}
			local i
			for i=1,#objlist,1 do
				local obj=objlist[i]
				if(obj.combat~=nil)then
					--TODO: not isa
					if(obj:isa(TRAININGGROUNDS_Enemy))then		
						tinsert(wowlist,obj)
					end
				end
			end
			
			
			for i=1,#wowlist,1 do		
				local obj=wowlist[i]
				self.combat:ApplyDamageToEnemy(self.aoedamage,obj,self)
			end
		end)
	end
	-- --TODO: don't do this
	-- self.combat:QueueImpact(executespelltick+1000,
		-- function(tick)
			-- self.combat.character.z=1
		-- end)
	
end
