--TODO: split into DebugWindow_Debug
--		and DebugWindow_Statistics

TRAININGGROUNDS_DebugWindow = {}
TRAININGGROUNDS_DebugWindow.__index = TRAININGGROUNDS_DebugWindow

function TRAININGGROUNDS_DebugWindow.new()
	local self=setmetatable({}, TRAININGGROUNDS_DebugWindow)	
	return self
end

-- SCREENWIDTH and SCREENHEIGHT are the dimensions of the main game frame.
TRAININGGROUNDS_DebugWindow.SCREENWIDTH=854-640
--TRAININGGROUNDS_Game.SCREENWIDTH=1200	-- for debug menus
TRAININGGROUNDS_DebugWindow.SCREENHEIGHT=480
-- The actual window itself is slightly larger and contains the outer border and title bar.
TRAININGGROUNDS_DebugWindow.BORDERSIZE=2
TRAININGGROUNDS_DebugWindow.TITLEHEIGHT=20

function TRAININGGROUNDS_DebugWindow:setup(game)
	self.environments={}
	
	self.game=game

	self.frame=CreateFrame("Frame",nil,UIParent)
	self.frame:SetParent(UIParent)		
	self.frame:SetWidth(TRAININGGROUNDS_DebugWindow.SCREENWIDTH+TRAININGGROUNDS_DebugWindow.BORDERSIZE*2)
	self.frame:SetHeight(TRAININGGROUNDS_DebugWindow.SCREENHEIGHT+TRAININGGROUNDS_DebugWindow.TITLEHEIGHT+TRAININGGROUNDS_DebugWindow.BORDERSIZE*2)
	--window is currently being positioned from game transition when it becomes visible
	self.frame:SetPoint("CENTER",0,0)

	if(not (_TRAININGGROUNDS.debug_dontscreenclamp==true))then
		self.frame:SetClampedToScreen(true)
	end
	self.frame.framelevel=1
	self.frame:SetFrameLevel(self.frame.framelevel)
	self.frame.texture=self.frame:CreateTexture()
	self.frame.texture:SetAllPoints(self.frame)
	self.frame.texture:SetTexture(0,0,0,0.75)	
	self.frame.texture:Show()
	self.frame:Show()
	self:SetGameWindowScale()

	local title=self.frame:CreateTitleRegion()				
	title:SetPoint("TOPLEFT",self.frame,"TOPLEFT",0,0)		-- remember, this is the draggable title bar we're setting,
	title:SetPoint("TOPRIGHT",self.frame,"TOPRIGHT",0,0)	-- so use TOPLEFT/TOPRIGHT instead of BOTTOMLEFT/BOTTOMRIGHT
	title:SetHeight(TRAININGGROUNDS_DebugWindow.TITLEHEIGHT)
	self.frame:EnableMouse(true)
	
		
	self.gameframe=CreateFrame("Frame",nil,UIParent)
	self.gameframe:SetParent(self.frame)		
	self.gameframe:SetWidth(TRAININGGROUNDS_DebugWindow.SCREENWIDTH)
	self.gameframe:SetHeight(TRAININGGROUNDS_DebugWindow.SCREENHEIGHT)
	self.gameframe:SetPoint("BOTTOM",self.frame,"BOTTOM",0,TRAININGGROUNDS_DebugWindow.BORDERSIZE)
	self.gameframe.framelevel=1
	self.gameframe:SetFrameLevel(self.gameframe.framelevel)					
	self.gameframe:Show()		

	
	self.border=TRAININGGROUNDS_BorderGraphicWithTitle.new()
	self.border:setup(self.frame,"Statistics",TRAININGGROUNDS_DebugWindow.TITLEHEIGHT)		
	
	

	--tinsert(self.environments,self.environment_ui)
end


function TRAININGGROUNDS_DebugWindow:RepositionDebugWindowForTheFirstTime()
	if(self.alreadyrepositioned~=true)then
		self.alreadyrepositioned=true
		self:RepositionDebugWindow()		
	end
end

function TRAININGGROUNDS_DebugWindow:RepositionDebugWindow()
	local mainwindow=self.game.frame
	local mainwindowx=mainwindow:GetLeft()
	local mainwindowx2=mainwindow:GetRight()
	local mainwindowcenter=(mainwindowx2+mainwindowx)/2
	local mainwindowy=mainwindow:GetBottom()
	local screenwidth=GetScreenWidth()
	--print("mainwindow: ",mainwindowx, mainwindowcenter, mainwindowx2)
	--print("screenwidth: ",screenwidth)
	
	if(mainwindowcenter<=screenwidth/2)then
		self.frame:ClearAllPoints()
		self.frame:SetPoint("LEFT",self.game.frame,"RIGHT",5,0)		
	else
		self.frame:ClearAllPoints()
		self.frame:SetPoint("RIGHT",self.game.frame,"LEFT",-5,0)		
	end
end

function TRAININGGROUNDS_DebugWindow:SetGameWindowScale()
	if(_TRAININGGROUNDS.debug_dontautosize==true)then
		self.frame:SetScale(1)
	else
		self.frame:SetScale(1/UIParent:GetEffectiveScale())
	end
	if(self.environments~=nil)then
		for i,v in ipairs(self.environments) do
			if(v.camera~=nil)then
				v.camera.forceupdate=true
			end
		end
	end
end


function TRAININGGROUNDS_DebugWindow:Cleanup()	
	--TODO:

	self.border:Cleanup()
	

	for i,v in ipairs(self.environments) do
		v:Cleanup()
	end
	
	self.frame:Hide()	
	
end