-- Special bordergraphic designed for use with window frames
-- (read: pretty much only the main Game frame)

TRAININGGROUNDS_BorderGraphicWithTitle = {}
TRAININGGROUNDS_BorderGraphicWithTitle.__index = TRAININGGROUNDS_BorderGraphicWithTitle

function TRAININGGROUNDS_BorderGraphicWithTitle.new()
	local self=setmetatable({}, TRAININGGROUNDS_BorderGraphicWithTitle)	
		
	return self
end

function TRAININGGROUNDS_BorderGraphicWithTitle:setup(parentframe,titletext,titleheight)
	self.parent=parentframe	
	

	self.top=TRAININGGROUNDS_ReusableFrames.getFrame()
	self.top:SetParent(parentframe)
	self.top:SetWidth(parentframe:GetWidth())
	self.top:SetHeight(2)
	self.top:SetPoint("TOPLEFT",parentframe,"TOPLEFT",0,0)
	self.top.texture:SetTexture(1,1,1,1)
	self.top:Show()
	self.top.texture:Show()

	self.titletext=TRAININGGROUNDS_ReusableFrames.getFrame()
	self.titletext:SetParent(parentframe)
	self.titletext:SetWidth(parentframe:GetWidth()-2)
	self.titletext:SetHeight(titleheight)
	self.titletext:SetPoint("TOPLEFT",parentframe,"TOPLEFT",2,0)
	self.titletext:Show()
	self.titletext.fontstring:SetJustifyH("LEFT")
	self.titletext.fontstring:SetText(titletext)
	self.titletext.fontstring:Show()
	
	
	self.titlebar=TRAININGGROUNDS_ReusableFrames.getFrame()
	self.titlebar:SetParent(parentframe)
	self.titlebar:SetWidth(parentframe:GetWidth())
	self.titlebar:SetHeight(2)
	self.titlebar:SetPoint("TOPLEFT",parentframe,"TOPLEFT",0,-(titleheight-2))
	self.titlebar.texture:SetTexture(1,1,1,1)
	self.titlebar:Show()
	self.titlebar.texture:Show()	
	
	self.bottom=TRAININGGROUNDS_ReusableFrames.getFrame()
	self.bottom:SetParent(parentframe)
	self.bottom:SetWidth(parentframe:GetWidth())
	self.bottom:SetHeight(2)
	self.bottom:SetPoint("BOTTOMLEFT",parentframe,"BOTTOMLEFT",0,0)
	self.bottom.texture:SetTexture(1,1,1,1)
	self.bottom:Show()
	self.bottom.texture:Show()	
	
	self.left=TRAININGGROUNDS_ReusableFrames.getFrame()
	self.left:SetParent(parentframe)
	self.left:SetWidth(2)
	self.left:SetHeight(parentframe:GetHeight())
	self.left:SetPoint("TOPLEFT",parentframe,"TOPLEFT",0,0)
	self.left.texture:SetTexture(1,1,1,1)
	self.left:Show()
	self.left.texture:Show()
	
	self.right=TRAININGGROUNDS_ReusableFrames.getFrame()
	self.right:SetParent(parentframe)
	self.right:SetWidth(2)
	self.right:SetHeight(parentframe:GetHeight())
	self.right:SetPoint("TOPRIGHT",parentframe,"TOPRIGHT",0,0)
	self.right.texture:SetTexture(1,1,1,1)
	self.right:Show()
	self.right.texture:Show()	
end

function TRAININGGROUNDS_BorderGraphicWithTitle:Cleanup()
	TRAININGGROUNDS_ReusableFrames.removeFrame(self.top)
	TRAININGGROUNDS_ReusableFrames.removeFrame(self.titletext)
	TRAININGGROUNDS_ReusableFrames.removeFrame(self.titlebar)
	TRAININGGROUNDS_ReusableFrames.removeFrame(self.bottom)
	TRAININGGROUNDS_ReusableFrames.removeFrame(self.left)
	TRAININGGROUNDS_ReusableFrames.removeFrame(self.right)	
end