-- ...not actually a pause menu.
-- currently placed in environment_ui, not environment_menu.

TRAININGGROUNDS_MenuController_PauseMenu = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_MenuController)

function TRAININGGROUNDS_MenuController_PauseMenu:setup(environment)
	TRAININGGROUNDS_MenuController.setup(self,environment)
	

	--menuframe.frame.framelevel=510
	--menuframe.frame:SetFrameLevel(menuframe.frame.framelevel)
	
	-- -- bordergraphic isn't a gameobject, careful with setup
	-- local border=TRAININGGROUNDS_BorderGraphic.new()
	-- border:setup(menuframe.frame)	
	-- self.border=border
	
	
	--TRAININGGROUNDS_FrameVisibilityCheck(menuframe.frame)
	
	--self:ShowAll()
	self.visible=false
end


function TRAININGGROUNDS_MenuController_PauseMenu:step(elapsed)
	TRAININGGROUNDS_MenuController.step(self,elapsed)
	
	local player=self.environment.game.environment_world.player
	if(player~=nil)then
		player.pausemenucontroller=self
	else		
		if(self.environment.game.keys.esc.pressed==true)then
			self:ToggleMenu()
		end
	end
end

function TRAININGGROUNDS_MenuController_PauseMenu:ToggleMenu()
	if(self.visible==true)then
		self:HideAll()
	else
		self:ShowAll()
	end
end


function TRAININGGROUNDS_MenuController_PauseMenu:ShowAll()
	self.visible=true
	
	local menucontroller=self
	
	local borderwidth=200
	local borderheight=320
	local buttonwidth=160
	local buttonheight=50
	local buttonyspacing=75
	local menuframe=TRAININGGROUNDS_MenuFrame.new()
	menuframe:setup(self.environment)
	menuframe:Resize(borderwidth,borderheight)
	menuframe.x=TRAININGGROUNDS_Game.SCREENWIDTH/2-borderwidth/2;menuframe.y=-TRAININGGROUNDS_Game.SCREENHEIGHT/2+borderheight/2
	menuframe.clickable=false
	menuframe.frame.texture:SetTexture(0,0,0,0.75)
	--menuframe.frame.texture:SetTexture(0,0,0,0)
	menuframe.frame.texture:Show()
	menuframe:SetCurrentAlpha(0); menuframe.targetalpha=1	
	self.menuframe=menuframe
	
	self.menubuttons={}
	
	local menubutton=TRAININGGROUNDS_MenuButton.new();	menubutton:setup(self.environment)	
	menubutton.x=TRAININGGROUNDS_Game.SCREENWIDTH/2-buttonwidth/2;	menubutton.y=-TRAININGGROUNDS_Game.SCREENHEIGHT/2+buttonheight/2+buttonyspacing*1.5
	menubutton:Resize(buttonwidth,buttonheight);	menubutton:SetText("Resume"); menubutton:SetCurrentAlpha(0); menubutton.targetalpha=1	
	menubutton.frame:SetScript("OnClick",function() ActionButton_ShowOverlayGlow(menubutton.frame); menucontroller:HideAll(); end)
	menubutton.frame:SetFrameLevel(menuframe.frame:GetFrameLevel()+1)
	tinsert(self.menubuttons,menubutton)
		
	local menubutton=TRAININGGROUNDS_MenuButton.new();	menubutton:setup(self.environment)	
	menubutton.x=TRAININGGROUNDS_Game.SCREENWIDTH/2-buttonwidth/2;	menubutton.y=-TRAININGGROUNDS_Game.SCREENHEIGHT/2+buttonheight/2+buttonyspacing*.5
	menubutton:Resize(buttonwidth,buttonheight);	menubutton:SetText("Restart scenario") ; menubutton:SetCurrentAlpha(0); menubutton.targetalpha=1	
	menubutton.frame:SetScript("OnClick",function() ActionButton_ShowOverlayGlow(menubutton.frame); _TRAININGGROUNDS.game:StartGame(); end)
	menubutton.frame:SetFrameLevel(menuframe.frame:GetFrameLevel()+1)
	tinsert(self.menubuttons,menubutton)

	local menubutton=TRAININGGROUNDS_MenuButton.new();	menubutton:setup(self.environment)	
	menubutton.x=TRAININGGROUNDS_Game.SCREENWIDTH/2-buttonwidth/2;	menubutton.y=-TRAININGGROUNDS_Game.SCREENHEIGHT/2+buttonheight/2-buttonyspacing*.5
	menubutton:Resize(buttonwidth,buttonheight);	menubutton:SetText("Main menu") ; menubutton:SetCurrentAlpha(0); menubutton.targetalpha=1		
	menubutton.frame:SetScript("OnClick",function() ActionButton_ShowOverlayGlow(menubutton.frame); _TRAININGGROUNDS.game:QuitLevelAndReturnToMenu(); end)
	menubutton.frame:SetFrameLevel(menuframe.frame:GetFrameLevel()+1)
	tinsert(self.menubuttons,menubutton)
	
	local menubutton=TRAININGGROUNDS_MenuButton.new();	menubutton:setup(self.environment)	
	menubutton.x=TRAININGGROUNDS_Game.SCREENWIDTH/2-buttonwidth/2;	menubutton.y=-TRAININGGROUNDS_Game.SCREENHEIGHT/2+buttonheight/2-buttonyspacing*1.5
	menubutton:Resize(buttonwidth,buttonheight);	menubutton:SetText("Close addon") ; menubutton:SetCurrentAlpha(0); menubutton.targetalpha=1		
	menubutton.frame:SetScript("OnClick",function() ActionButton_ShowOverlayGlow(menubutton.frame); _TRAININGGROUNDS:die(); end)
	menubutton.frame:SetFrameLevel(menuframe.frame:GetFrameLevel()+1)
	tinsert(self.menubuttons,menubutton)
	
--	TRAININGGROUNDS_FrameVisibilityCheck(menuframe.frame)
--	TRAININGGROUNDS_FrameVisibilityCheck(menubutton.frame)
end

function TRAININGGROUNDS_MenuController_PauseMenu:HideAll()
	self.visible=false
	
	self.menuframe.expirytime=self.environment.currenttime+1000
	self.menuframe.targetalpha=0

	local i
	for i=1,#self.menubuttons,1 do
		self.menubuttons[i].frame:EnableMouse(false)
		self.menubuttons[i].expirytime=self.environment.currenttime+1000
		self.menubuttons[i].targetalpha=0
	end	
	self.menubuttons={}
end



function TRAININGGROUNDS_MenuController_PauseMenu:Cleanup()	
	self.menuframe=nil
	self.menubuttons={}
end
