

-- TODO: at the moment, frame cleanup doesn't account for button properties

TRAININGGROUNDS_ReusableButtonFrames = {}

TRAININGGROUNDS_ReusableButtonFrames.inactiveframes={}
TRAININGGROUNDS_ReusableButtonFrames.activeframes={}

function TRAININGGROUNDS_ReusableButtonFrames.removeFrame(f)
	f:Hide()
	f:ClearAllPoints()	
	
	f:SetScript("OnClick",nil)
	f:SetScript("OnEnter",nil)
	f:SetScript("OnLeave",nil)
	--TODO: find out if this is redundant or necessary or even if anything we're doing actually prevents memory leaks
	f:UnregisterAllEvents()
	-- mouse is enabled by default, so if we disabled it, turn it back on here
	f:EnableMouse(true)
	
	f.texture:SetTexture(0,1,1,0.5)	
	f.texture:SetTexCoord(0,1,0,1)	
	f.texture:SetGradientAlpha("HORIZONTAL",1,1,1,1,1,1,1,1)
	f:SetHighlightTexture(nil)
	f.texture:Hide()
	f.fontstring:Hide()
	f.fontstring:SetFont("Fonts\\FRIZQT__.TTF",14,"OUTLINE")
	f.fontstring:SetJustifyH("CENTER")
	f.fontstring:SetTextHeight(14)
	--f:SetParent(nil)
	f:SetParent(UIParent)
	f.framelevel=0
	f:SetFrameLevel(f.framelevel)
	ActionButton_HideOverlayGlow(f) --!!!
	
	f.cooldown:Hide()
	
	
	if(f.animgroup~=nil) then
		f.animgroup:Stop()
		f.animgroup=nil
	end
	if(f.texture.animgroup~=nil)then
		f.texture.animgroup:Stop()
		f.texture.animgroup=nil
	end
	f:SetAlpha(1)
	
	_TRAININGGROUNDS:tremovebyval(TRAININGGROUNDS_ReusableButtonFrames.activeframes,f)	
	if(TRAININGGROUNDS_tcontains(TRAININGGROUNDS_ReusableButtonFrames.inactiveframes,f))then
		--print("WARNING: TRAININGGROUNDS_ReusableButtonFrames.inactiveframes already contains "..tostring(f))
	else
		tinsert(TRAININGGROUNDS_ReusableButtonFrames.inactiveframes,f)
	end
	
end

TRAININGGROUNDS_ReusableButtonFrames.nextframeid=0
function TRAININGGROUNDS_ReusableButtonFrames.getFrame()
	local f=tremove(TRAININGGROUNDS_ReusableButtonFrames.inactiveframes)
	if not f then
		local framename="TRAININGGROUNDS_ReusableButtonFrame"..tostring(TRAININGGROUNDS_ReusableButtonFrames.nextframeid);
		f=CreateFrame("Button",framename,UIParent)
		f.id=TRAININGGROUNDS_ReusableButtonFrames.nextframeid
		f.name=framename
		f.framelevel=0
		f:SetFrameLevel(f.framelevel)		
		f:Hide()
		f.texture = f:CreateTexture()
		f.texture:SetAllPoints(f)
		f.texture:SetTexture(0,1,1,0.5)		
		f.texture:Hide()
		f.cooldown=CreateFrame("Cooldown",framename.."_Cooldown",f,"CooldownFrameTemplate")
		f.cooldown:SetAllPoints()
		f.cooldown:Hide()
		f.fontstring=f:CreateFontString(nil, "ARTWORK")
		f.fontstring:SetAllPoints()
		f.fontstring:Hide()
		f.fontstring:SetFont("Fonts\\FRIZQT__.TTF",14,"OUTLINE")
		f.fontstring:SetTextHeight(14)	
		f.animgroup=nil
		f.Cleanup=TRAININGGROUNDS_ReusableButtonFrames.removeFrame

		
		TRAININGGROUNDS_ReusableButtonFrames.nextframeid=TRAININGGROUNDS_ReusableButtonFrames.nextframeid+1
	else
		--
	end
	--print("ReusableButtonFrames getting a frame ",f.name)
	tinsert(TRAININGGROUNDS_ReusableButtonFrames.activeframes,f)
	return f
end

function TRAININGGROUNDS_ReusableButtonFrames.resetAllInactiveFrames()
	local looping=true
	while looping==true do
		looping=false
		local f
		f=nil
		if(#TRAININGGROUNDS_ReusableButtonFrames.activeframes>0) then			
			f=TRAININGGROUNDS_ReusableButtonFrames.activeframes[1]
		end
		if not f then
			--
		else
			TRAININGGROUNDS_ReusableButtonFrames.removeFrame(f)
			looping=true
			
			if(f:GetParent()~=UIParent)then
				--print("WARNING: during force cleanup, buttonframe "..tostring(f:GetName()).."'s parent is not UIParent but "..tostring(f:GetParent():GetName()).." instead")
			end
			--print("Force cleanup on ReusableButtonFrames: "..#TRAININGGROUNDS_ReusableButtonFrames.activeframes.." frames remaining")
		end
	end
end

