-- Each scrollframe comes with its own frame.  frame is f; scrollframe is f.scrollframe
-- After calling getFrame, be sure to manually call SetScrollChild.
-- We call SetScrollChild during getFrame, but it tends to break if you make any adjustments afterwards.


TRAININGGROUNDS_ReusableScrollFrames = {}

TRAININGGROUNDS_ReusableScrollFrames.inactiveframes={}
TRAININGGROUNDS_ReusableScrollFrames.activeframes={}

function TRAININGGROUNDS_ReusableScrollFrames.removeFrame(f)
	f:Hide()
	f:ClearAllPoints()	
	f.scrollframe:ClearAllPoints()
	f.scrollframe:SetHorizontalScroll(0)
	f.scrollframe:SetVerticalScroll(0)
	f.texture:SetTexture(0,1,1,0.5)
	f.texture:SetTexCoord(0,1,0,1)
	f.texture:SetGradientAlpha("HORIZONTAL",1,1,1,1,1,1,1,1)
	f.texture:Hide()
	f.fontstring:Hide()
	f.fontstring:SetFont("Fonts\\FRIZQT__.TTF",14,"OUTLINE")
	f.fontstring:SetJustifyH("CENTER")
	f.fontstring:SetTextHeight(14)	
	f.framelevel=0
	f:SetFrameLevel(f.framelevel)	
	--f:SetParent(nil)
	f:SetParent(UIParent)
	
	f.scrollframe:Hide()
	f.scrollframe:SetParent(nil)

	if(f.animgroup~=nil) then
		f.animgroup:Stop()
		f.animgroup=nil
	end
	if(f.texture.animgroup~=nil)then
		f.texture.animgroup:Stop()
		f.texture.animgroup=nil
	end
	f:SetAlpha(1)
	f.scrollframe:SetAlpha(1)
	
	_TRAININGGROUNDS:tremovebyval(TRAININGGROUNDS_ReusableScrollFrames.activeframes,f)	
	if(TRAININGGROUNDS_tcontains(TRAININGGROUNDS_ReusableScrollFrames.inactiveframes,f))then
		--print("WARNING: TRAININGGROUNDS_ReusableScrollFrames.inactiveframes already contains "..tostring(f))
	else
		tinsert(TRAININGGROUNDS_ReusableScrollFrames.inactiveframes,f)
	end
	
end

TRAININGGROUNDS_ReusableScrollFrames.nextframeid=0
function TRAININGGROUNDS_ReusableScrollFrames.getFrame()
	local f=tremove(TRAININGGROUNDS_ReusableScrollFrames.inactiveframes)
	if not f then
		local framename="TRAININGGROUNDS_ReusableScrollFrame"..tostring(TRAININGGROUNDS_ReusableScrollFrames.nextframeid);
		f=CreateFrame("Frame",framename,UIParent)
		f.id=TRAININGGROUNDS_ReusableScrollFrames.nextframeid
		f.name=framename
		f.framelevel=0
		f:SetFrameLevel(f.framelevel)		
		f:Hide()
		f.texture = f:CreateTexture()
		f.texture:SetAllPoints(f)
		f.texture:SetTexture(0,1,1,0.5)		
		f.texture:SetGradientAlpha("HORIZONTAL",1,1,1,1,1,1,1,1);
		f.texture:Hide()		
		f.fontstring=f:CreateFontString(nil, "ARTWORK")
		f.fontstring:SetAllPoints()
		f.fontstring:Hide()
		f.fontstring:SetFont("Fonts\\FRIZQT__.TTF",14,"OUTLINE")
		f.fontstring:SetTextHeight(14)	
		f.animgroup=nil		
		f.Cleanup=TRAININGGROUNDS_ReusableScrollFrames.removeFrame
		
		f.scrollframe=CreateFrame("ScrollFrame",framename.."_scrollframe",UIParent)
		f.scrollframe.name=framename
		f.scrollframe.framelevel=0
		f.scrollframe:SetFrameLevel(f.framelevel)		
		f.scrollframe:Hide()
				
		f.scrollframe:SetScrollChild(f)
		
		
		
		
		TRAININGGROUNDS_ReusableScrollFrames.nextframeid=TRAININGGROUNDS_ReusableScrollFrames.nextframeid+1
	else
		--
	end
	--print("Got a frame: "..f.name)
	tinsert(TRAININGGROUNDS_ReusableScrollFrames.activeframes,f)
	return f
end

function TRAININGGROUNDS_ReusableScrollFrames.resetAllInactiveFrames()
	local looping=true
	while looping==true do
		looping=false
		local f
		f=nil
		if(#TRAININGGROUNDS_ReusableScrollFrames.activeframes>0) then			
			f=TRAININGGROUNDS_ReusableScrollFrames.activeframes[1]
		end
		if not f then
			--
		else
			TRAININGGROUNDS_ReusableScrollFrames.removeFrame(f)
			looping=true
			if(f:GetParent()~=UIParent)then
				--print("WARNING: during force cleanup, scrollframe "..tostring(f:GetName()).."'s parent is not UIParent but "..tostring(f:GetParent():GetName()).." instead")
			end
			--print("Force cleanup on ReusableScrollFrames: "..#TRAININGGROUNDS_ReusableScrollFrames.activeframes.." frames remaining")
		end
	end
end

