TRAININGGROUNDS_ScenarioController = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_GameObject)

function TRAININGGROUNDS_ScenarioController:SetCustomInfo()
	TRAININGGROUNDS_GameObject.SetCustomInfo(self)
	
	
	self.queuedtypewriters={}
	self.typewriters={}	
	self.mostrecenttypewriter=nil
	self.typewriterdelayendtick=0
	--TODO: "nudge" option that unlocks all "locked" typewriters
	-- and makes them expire EITHER (choose one) immediately, OR when the next typewriter completes
end

function TRAININGGROUNDS_ScenarioController:step(elapsed)
	TRAININGGROUNDS_GameObject.step(self,elapsed)
	
	
	local currenttime=self.environment.currenttime
	local i
	
	
	for i=#self.typewriters,1,-1 do
		local obj=self.typewriters[i]
		if(obj.dead==true) then
			tremove(self.typewriters,i)
		end
	end
	
	
	local targety=-100
	for i=#self.typewriters,1,-1 do		
		-- "Typewriter Message"
		local tm=self.typewriters[i]		
		tm.targety=targety
		targety=targety+tm.textheight+2	
	end
	
	for i=1,#self.typewriters,1 do
		local tm=self.typewriters[i]
		if(tm.y<tm.targety)then
			tm.y=tm.y+100*elapsed
			if(tm.y>tm.targety)then
				tm.y=tm.targety
			end
		end
	end
	
	-- must do activation check before queue check
	-- or the new typewriter will be activated on the same frame it comes off queue
	-- (before any previous typewriters move up yet)
	if(#self.typewriters>0)then
		local tm=self.typewriters[#self.typewriters]
		if(tm.activated==false)then
			if(#self.typewriters<=1)then
				tm.activated=true
			else
				local tm2=self.typewriters[#self.typewriters-1]
				if(tm2.y>=tm2.targety)then
					tm.activated=true
				end
			end
		end
	end	
	
	if(#self.queuedtypewriters>0)then
		local nexttypewriterok=false
		--print("Typewriters: ",#self.typewriters)
		if(self.typewriterdelayendtick<=currenttime)then
			if(#self.typewriters==0)then
				nexttypewriterok=true
			else
				local tm=self.typewriters[#self.typewriters]
				--print(tm.letterindex," ",#tm.targetmessage)
				if(tm.letterindex>=#tm.targetmessage)then
					nexttypewriterok=true
				end
			end
		end
		if(nexttypewriterok==true)then			
			local tm=self.queuedtypewriters[1]
			tremove(self.queuedtypewriters,1)
			--print(tm.targetmessage)
			if(tm.targetmessage=="|CLEAR")then
				self:ClearTypewriters()
				tm:die()
			elseif(tm.targetmessage=="|PAUSE")then
				if(self.typewriterdelayendtick<currenttime)then self.typewriterdelayendtick=currenttime end
				self.typewriterdelayendtick=self.typewriterdelayendtick+1000
				tm:die()
			else
				tinsert(self.typewriters,tm)
			end
			--print("now Typewriters: ",#self.typewriters)
			--new typewriter still can't start typing until previous typewriters are pushed up			
		end
	end
end

function TRAININGGROUNDS_ScenarioController:ClearTypewriters()
	for i=1,#self.typewriters,1 do
		local tm=self.typewriters[i]
		if(tm.expirytime==nil)then
			tm.postexpirytime=1000
		end
	end
end