TRAININGGROUNDS_ScenarioController_EndlessWaves = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_ScenarioController)


function TRAININGGROUNDS_ScenarioController_EndlessWaves:SetCustomInfo()
	TRAININGGROUNDS_ScenarioController.SetCustomInfo(self)
	
	self.ysortable=false
	
	self.states={}
	
	local i=0
	i=i+1;self.states.SETUP=i
	i=i+1;self.states.TEXT=i
	i=i+1;self.states.ZOOMIN=i
	i=i+1;self.states.MENU=i	
	i=i+1;self.states.END=i

	self.state=nil
	self.nextstate=self.states.SETUP
	self.statetimer=0
	
	-- self.sauroks={}
	-- self.sefs={}
	
	self.talentstring=""
	
	if(_TRAININGGROUNDS.game.targettalents==1)then
		self.talentstring="Chi Wave, Ascension, Xuen, and Serenity"
	elseif(_TRAININGGROUNDS.game.targettalents==2)then
		self.talentstring="EotT, Power Strikes, Xuen, and Chi Orbit"
	elseif(_TRAININGGROUNDS.game.targettalents==3)then
		self.talentstring="Chi Burst, Energizing Elixir, RJW, and WDP"
	elseif(_TRAININGGROUNDS.game.targettalents==4)then
		self.talentstring="Chi Wave, Ascension, RJW, and Serenity"
	elseif(_TRAININGGROUNDS.game.targettalents==5)then
		self.talentstring="Chi Burst, Energizing Elixir, Xuen, and WDP"
	elseif(_TRAININGGROUNDS.game.targettalents==6)then
		self.talentstring="Chi Wave, Ascension, Hit Combo, and WDP"
	end
	local haste=(_TRAININGGROUNDS.game.targethaste-1)*10
	self.hastestring=tostring(haste).."% Haste"

	
	self.enemies={}
	self.currentwave=0
	self.waverotation=0
end

function TRAININGGROUNDS_ScenarioController_EndlessWaves:step(elapsed)
	TRAININGGROUNDS_ScenarioController.step(self,elapsed)
	
	local currenttime=self.environment.currenttime
	

	
	if(self.statetimer~=nil)then
		if(self.mostrecenttypewriter==nil
			or (self.mostrecenttypewriter.letterindex>=#self.mostrecenttypewriter.targetmessage)
			or self.mostrecenttypewriter.dontlock==true
			or self.mostrecenttypewriter.dead==true)then
			self.statetimer=self.statetimer-elapsed*1000
		end
		--print(self.statetimer)
		if(self.statetimer<=0)then	
			self.statetimer=0
			self.state=self.nextstate
		
			if(self.state==self.states.SETUP)then
				-- must set camera zoom before creating objects
				-- or the objects appear in wrong scale
				self.environment.camera.targetzoom=.35
				self.environment.camera.zoom=self.environment.camera.targetzoom
				
			
				local arenaborder=TRAININGGROUNDS_ArenaBorder.new()
				arenaborder:setup(self.environment)	
				arenaborder.frame.framelevel=1
				arenaborder.frame:SetFrameLevel(arenaborder.frame.framelevel)

				local player=TRAININGGROUNDS_PlayerCharacter.new()
				self.environment.player=player
				player:setup(self.environment)
				--player.x=-50;player.y=-50
				player.x=150;player.y=-150	--!!!
				player:SetAdjustedFacing(0)	--we'll face towards saurok in a moment
				player.combat=TRAININGGROUNDS_CombatModule_W7_WindwalkerMonk.new()
				player.combat:setup(player)
				player.combat:CreateVisibleFrames()	-- channelbar
				player.combat:SetMaximumAndCurrentHP(TRAININGGROUNDS_CombatModule_W7_WindwalkerMonk.PLAYERHP) -- 6.2 PTR
				player.combat:CreateSpellButtons()
				
				self.player=player
				
				local enemy
				enemy=TRAININGGROUNDS_Enemy_W7_ProvingGrounds_LargeIllusionarySlayer.new()
				enemy:setup(self.environment)
				fadein=TRAININGGROUNDS_Buff_Tutorial_VisualFadeIn.new();fadein:setup(enemy.combat,self.environment.currenttime)
				tinsert(self.enemies,enemy)
				if(_TRAININGGROUNDS.debug_autoscenario==true)then
					enemy.combat.hp.value=0
				end
				
				--force resize nameplates
				player.forceresizeframe=true
				enemy.forceresizeframe=true
				
				-- -- SEF costume -- don't erase this!
				-- --(enabled[,omni,dirX,dirY,dirZ,       ambIntensity[,ambR,ambG,ambB [,dirIntensity[,dirR,dirG,dirB]]]])
				-- player.modelframe:SetLight(1,0,-1,0,0, 4.0, 0.25,1.0,0.25, 0,1,1,1)
				-- player.modelframe:SetAlpha(0.75)
				-- player.modelframe:TryOn(59270)
				-- --player.modelframe:UndressSlot(1)	-- helmet				
				-- --TODO: brewmaster keg for green sef (if possible)				
				-- self.sefs[1].modelframe:SetLight(1,0,-1,0,0, 4.0, 0.25,0.25,1, 0,1,1,1)
				-- self.sefs[1].modelframe:SetAlpha(0.75)
				-- self.sefs[1].modelframe:TryOn(90844)
				-- self.sefs[1].modelframe:TryOn(25197)
				-- self.sefs[1].modelframe:TryOn(25197)
				-- self.sefs[2].modelframe:SetLight(1,0,-1,0,0, 4.0, 1,0.25,0.25, 0,1,1,1)
				-- self.sefs[2].modelframe:SetAlpha(0.75)				
				-- self.sefs[2].modelframe:TryOn(83649)
				-- self.sefs[2].modelframe:TryOn(82059)
				-- self.sefs[2].modelframe:TryOn(82059)
				
				self.statetimer=2000	--!!!
				self.nextstate=self.states.TEXT

			elseif(self.state==self.states.TEXT)then		
				--!!!
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"- Endless Waves -")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,self.talentstring)
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,self.hastestring)
				

				self.statetimer=2000
				self.nextstate=self.states.ZOOMIN
			elseif(self.state==self.states.ZOOMIN)then
				-- --!!!
				-- --TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")
				--we want to stay zoomed out just enough that damage particles are still visible
				self.environment.camera.targetzoom=.85
				
				self.environment.camera:ChangeFocus(self.player)
				
				self.player.combat:CreateNameplate()
				
				self.statetimer=1000
				self.nextstate=self.states.MENU
				
			elseif(self.state==self.states.MENU)then						
				--!!!
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"This stage goes on forever.")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"To quit, press |cFFFFFF00Esc|cFFFFFFFF to clear your current target,")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"then press |cFFFFFF00Esc|cFFFFFFFF again to open the menu.")
				self.statetimer=3000
				self.nextstate=self.states.END			
			elseif(self.state==self.states.END)then
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")

				self.statetimer=nil
			end
			--self.environment.player.combat:CreateTutorialSpellButtons(3)
			--
		end
	end
	
	
	-- if(self.player~=nil and self.player.combat~=nil)then
		-- local i
		-- for i=1,2,1 do
			-- if(self.sefs[i]~=nil)then
				-- if(#self.sefs[i].combat.spellqueue==0)then
					-- if(#self.player.combat.spellqueue>0)then
						-- --print("ScenarioController -- Thing in queue")
						-- local j
						-- --TODO:
						-- for j=1,#self.sefs[i].combat.spellbook,1 do
							-- --print(self.sefs[i].combat.spellbook[j].spellname)
							-- if(self.player.combat.spellqueue[1].spellname==self.sefs[i].combat.spellbook[j].spellname)then
								-- tinsert(self.sefs[i].combat.spellqueue,self.sefs[i].combat.spellbook[j])
								-- j=#self.sefs[i].combat.spellbook+1
							-- end
						-- end						
					-- end
				-- end				
			-- end
		-- end
	-- end

	
	-- --TODO: debug skip
	if(_TRAININGGROUNDS.debug_autoscenario==true)then
		--if(self.state<self.states.PRESS1ATTACK)then
		--if(self.state<self.states.WAITFORZOOM)then
		--if(self.state<self.states.PRESS8ROLL)then
		-- if(self.state<self.states.SETUPPHASE2)then
			-- if(self.player~=nil)then
				-- self.player.x=0;self.player.y=0
			-- end
			-- self.statetimer=0
		-- end
		if(self.state<self.states.END)then
			self.statetimer=0
		end
		-- if(self.player~=nil and self.nextstate<self.states.SPEEDBOOST)then
			-- self.nextstate=self.states.SPEEDBOOST
		-- end
	end
	
	
	if(self.state<self.states.ZOOMIN)then
		self.environment.camera.targetzoom=.35
	end
	
	local nextwave=true
	if(self.state==self.states.END)then
		for i=1,#self.enemies,1 do
			if(self.enemies[i].dead~=true)then
				nextwave=false
				i=#self.enemies+1	--break
			end
		end
		if(nextwave==true)then
			self.enemies={}
			local enemy,fadein,facing
			if(self.currentwave>3 and self.currentwave%4==0)then
				--that was the last wave; rotate next set of waves
				self.waverotation=self.waverotation+math.pi+(math.random()-0.5)*math.pi
			end
			self.currentwave=self.currentwave+1
			
			if(_TRAININGGROUNDS.debug_autoscenario==true)then
				self.currentwave=3
			end
			
			local modulowave=self.currentwave % 4
			if(modulowave==1)then
				local spacing=200
				enemy=TRAININGGROUNDS_Enemy_W7_ProvingGrounds_SmallIllusionaryGuardian.new();enemy:setup(self.environment)				
				enemy.x=-spacing;enemy.y=0;enemy.currentfacing=0;enemy.modelframe:SetFacing(enemy.currentfacing);self:RotateEnemyForWave(enemy,self.waverotation)
				tinsert(self.enemies,enemy)

				enemy=TRAININGGROUNDS_Enemy_W7_ProvingGrounds_LargeIllusionarySlayer.new();enemy:setup(self.environment)				
				enemy.x=0;enemy.y=0;enemy.currentfacing=0;enemy.modelframe:SetFacing(enemy.currentfacing);self:RotateEnemyForWave(enemy,self.waverotation)
				tinsert(self.enemies,enemy)

				enemy=TRAININGGROUNDS_Enemy_W7_ProvingGrounds_SmallIllusionaryGuardian.new();enemy:setup(self.environment)				
				enemy.x=spacing;enemy.y=0;enemy.currentfacing=0;enemy.modelframe:SetFacing(enemy.currentfacing);self:RotateEnemyForWave(enemy,self.waverotation)
				tinsert(self.enemies,enemy)
			end
			if(modulowave==2)then
				local spacing=200
				enemy=TRAININGGROUNDS_Enemy_W7_ProvingGrounds_SmallIllusionaryGuardian.new();enemy:setup(self.environment)				
				enemy.x=0;enemy.y=0;enemy.currentfacing=0;enemy.modelframe:SetFacing(enemy.currentfacing);self:RotateEnemyForWave(enemy,self.waverotation)
				tinsert(self.enemies,enemy)

				for i=1,4,1 do
					local angle=math.pi/2*i
					enemy=TRAININGGROUNDS_Enemy_W7_ProvingGrounds_LargeIllusionaryVarmint.new();enemy:setup(self.environment)				
					enemy.x=math.cos(angle)*spacing;enemy.y=math.sin(angle)*spacing;enemy.currentfacing=0;enemy.modelframe:SetFacing(enemy.currentfacing);self:RotateEnemyForWave(enemy,self.waverotation)
					tinsert(self.enemies,enemy)
				end

				for i=1,4,1 do
					local angle=math.pi/2*i+math.pi/4
					enemy=TRAININGGROUNDS_Enemy_W7_ProvingGrounds_SmallIllusionaryVarmint.new();enemy:setup(self.environment)				
					enemy.x=math.cos(angle)*spacing;enemy.y=math.sin(angle)*spacing;enemy.currentfacing=0;enemy.modelframe:SetFacing(enemy.currentfacing);self:RotateEnemyForWave(enemy,self.waverotation)
					tinsert(self.enemies,enemy)
				end	
				
				enemy=TRAININGGROUNDS_Enemy_W7_ProvingGrounds_SmallIllusionaryVarmint.new();enemy:setup(self.environment)				
				enemy.x=spacing*2;enemy.y=0;enemy.currentfacing=0;enemy.modelframe:SetFacing(enemy.currentfacing);self:RotateEnemyForWave(enemy,self.waverotation)
				tinsert(self.enemies,enemy)
				enemy=TRAININGGROUNDS_Enemy_W7_ProvingGrounds_SmallIllusionaryVarmint.new();enemy:setup(self.environment)				
				enemy.x=-spacing*2;enemy.y=0;enemy.currentfacing=0;enemy.modelframe:SetFacing(enemy.currentfacing);self:RotateEnemyForWave(enemy,self.waverotation)
				tinsert(self.enemies,enemy)

				
			end	
			
			if(modulowave==3)then
				local spacing=200
				enemy=TRAININGGROUNDS_Enemy_W7_ProvingGrounds_LargeIllusionaryVarmint.new();enemy:setup(self.environment)				
				enemy.x=0;enemy.y=0;enemy.currentfacing=0;enemy.modelframe:SetFacing(enemy.currentfacing);self:RotateEnemyForWave(enemy,self.waverotation)
				tinsert(self.enemies,enemy)
				
				for i=1,5,1 do
					local angle=(i-1)*-math.pi/4
					if(i==3)then
						enemy=TRAININGGROUNDS_Enemy_W7_ProvingGrounds_LargeIllusionaryVarmint.new();enemy:setup(self.environment)				
					else
						enemy=TRAININGGROUNDS_Enemy_W7_ProvingGrounds_SmallIllusionaryVarmint.new();enemy:setup(self.environment)				
					end
					enemy.x=math.cos(angle)*spacing;enemy.y=math.sin(angle)*spacing;enemy.currentfacing=0;enemy.modelframe:SetFacing(enemy.currentfacing);self:RotateEnemyForWave(enemy,self.waverotation)
					tinsert(self.enemies,enemy)
				end	

				enemy=TRAININGGROUNDS_Enemy_W7_ProvingGrounds_SmallIllusionaryGuardian.new();enemy:setup(self.environment)				
				enemy.x=spacing*3;enemy.y=0;enemy.currentfacing=0;enemy.modelframe:SetFacing(enemy.currentfacing);self:RotateEnemyForWave(enemy,self.waverotation)
				tinsert(self.enemies,enemy)
				enemy=TRAININGGROUNDS_Enemy_W7_ProvingGrounds_SmallIllusionaryGuardian.new();enemy:setup(self.environment)				
				enemy.x=-spacing*3;enemy.y=0;enemy.currentfacing=0;enemy.modelframe:SetFacing(enemy.currentfacing);self:RotateEnemyForWave(enemy,self.waverotation)
				tinsert(self.enemies,enemy)
				enemy=TRAININGGROUNDS_Enemy_W7_ProvingGrounds_SmallIllusionarySlayer.new();enemy:setup(self.environment)				
				enemy.x=0;enemy.y=-spacing*3;enemy.currentfacing=0;enemy.modelframe:SetFacing(enemy.currentfacing);self:RotateEnemyForWave(enemy,self.waverotation)
				tinsert(self.enemies,enemy)				
			end		

			if(modulowave==0)then		-- wave 4:  4 % 4 = 0
				enemy=TRAININGGROUNDS_Enemy_W7_ProvingGrounds_HugeIllusionarySlayer.new();enemy:setup(self.environment)				
				enemy.x=0;enemy.y=0;enemy.currentfacing=0;enemy.modelframe:SetFacing(enemy.currentfacing);self:RotateEnemyForWave(enemy,self.waverotation)
				tinsert(self.enemies,enemy)			
			end
			
			for i=1,#self.enemies,1 do
				fadein=TRAININGGROUNDS_Buff_Tutorial_VisualFadeIn.new();fadein:setup(self.enemies[i].combat,self.environment.currenttime)
				self.enemies[i].modelframe:SetAlpha(0)
			end
		end		
	end
end

function TRAININGGROUNDS_ScenarioController_EndlessWaves:RotateEnemyForWave(enemy,waverotation)
	local dist=math.sqrt(enemy.x*enemy.x+enemy.y*enemy.y)
	local angle=math.atan2(enemy.y,enemy.x)
	angle=angle+waverotation
	enemy.x=math.cos(angle)*dist
	enemy.y=math.sin(angle)*dist
	enemy.currentfacing=enemy.currentfacing+waverotation
	enemy:SetAdjustedFacing(enemy.currentfacing)
end