TRAININGGROUNDS_ScenarioController_SustainedWorkout = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_ScenarioController)


function TRAININGGROUNDS_ScenarioController_SustainedWorkout:SetCustomInfo()
	TRAININGGROUNDS_ScenarioController.SetCustomInfo(self)
	
	self.ysortable=false
	
	self.states={}
	
	local i=0
	i=i+1;self.states.SETUP=i
	i=i+1;self.states.TEXT=i
	i=i+1;self.states.ZOOMIN=i
	i=i+1;self.states.MENU=i	
	i=i+1;self.states.END=i

	self.state=nil
	self.nextstate=self.states.SETUP
	self.statetimer=0
	
	self.guldan=nil
	
	self.talentstring=""
	
	if(_TRAININGGROUNDS.game.targettalents==1)then
		self.talentstring="Chi Wave, Ascension, Xuen, and Serenity"
	elseif(_TRAININGGROUNDS.game.targettalents==2)then
		self.talentstring="EotT, Power Strikes, Xuen, and Chi Orbit"
	elseif(_TRAININGGROUNDS.game.targettalents==3)then
		self.talentstring="Chi Burst, Energizing Elixir, RJW, and WDP"
	elseif(_TRAININGGROUNDS.game.targettalents==4)then
		self.talentstring="Chi Wave, Ascension, RJW, and Serenity"
	elseif(_TRAININGGROUNDS.game.targettalents==5)then
		self.talentstring="Chi Burst, Energizing Elixir, Xuen, and WDP"
	elseif(_TRAININGGROUNDS.game.targettalents==6)then
		self.talentstring="Chi Wave, Ascension, Hit Combo, and WDP"
	end
	local haste=(_TRAININGGROUNDS.game.targethaste-1)*10
	self.hastestring=tostring(haste).."% Haste"

end

function TRAININGGROUNDS_ScenarioController_SustainedWorkout:step(elapsed)
	TRAININGGROUNDS_ScenarioController.step(self,elapsed)
	
	local currenttime=self.environment.currenttime
	

	
	if(self.statetimer~=nil)then
		if(self.mostrecenttypewriter==nil
			or (self.mostrecenttypewriter.letterindex>=#self.mostrecenttypewriter.targetmessage)
			or self.mostrecenttypewriter.dontlock==true
			or self.mostrecenttypewriter.dead==true)then
			self.statetimer=self.statetimer-elapsed*1000
		end
		--print(self.statetimer)
		if(self.statetimer<=0)then	
			self.statetimer=0
			self.state=self.nextstate
		
			if(self.state==self.states.SETUP)then
				-- must set camera zoom before creating objects
				-- or the objects appear in wrong scale
				self.environment.camera.targetzoom=.35
				self.environment.camera.zoom=self.environment.camera.targetzoom
				
			
				local arenaborder=TRAININGGROUNDS_ArenaBorder.new()
				arenaborder:setup(self.environment)	
				arenaborder.frame.framelevel=1
				arenaborder.frame:SetFrameLevel(arenaborder.frame.framelevel)

				local player=TRAININGGROUNDS_PlayerCharacter.new()
				self.environment.player=player
				player:setup(self.environment)
				player.x=-50;player.y=-50
				--player.x=0;player.y=50	--!!!
				player:SetAdjustedFacing(0)	--we'll face towards guldan in a moment
				player.combat=TRAININGGROUNDS_CombatModule_W7_WindwalkerMonk.new()
				player.combat:setup(player)
				player.combat:CreateVisibleFrames()	-- channelbar
				player.combat:SetMaximumAndCurrentHP(TRAININGGROUNDS_CombatModule_W7_WindwalkerMonk.PLAYERHP)
				player.combat:CreateSpellButtons()				
				self.player=player
				
				local guldan=TRAININGGROUNDS_Enemy_W7_Misc_Guldan.new()
				guldan:setup(self.environment);guldan.x=50;guldan.y=50;
				--guldan.combat:SetMaximumAndCurrentHP(TRAININGGROUNDS_CombatModule_W7_WindwalkerMonk.PLAYERHP) -- !!!
				self.guldan=guldan
				
				-- local xuen=TRAININGGROUNDS_Xuen.new()
				-- --guldan:setup(self.environment);guldan.x=50;guldan.y=50;
				-- xuen:setup(self.environment);xuen.x=200;xuen.y=200;	--!!!
				-- xuen.combat.target=guldan
				-- self.xuen=xuen			
				
				
				local facing=math.atan2(guldan.x-player.x,-(guldan.y-player.y))
				player:SetAdjustedFacing(facing)
				guldan:SetAdjustedFacing(facing+math.pi)
				--xuen:SetAdjustedFacing(facing+math.pi)

				-- --!!!
				-- ------------------------------------------------------
				-- guldan.x=9999
				
				-- local bigvirmen=TRAININGGROUNDS_Enemy_Tutorial_HugeVirmen.new()
				-- bigvirmen:setup(self.environment);bigvirmen.x=0;bigvirmen.y=0;
				-- bigvirmen.combat=TRAININGGROUNDS_CombatModule.new();
				-- bigvirmen.combat:setup(bigvirmen);bigvirmen.combat:SetMaximumAndCurrentHP(TRAININGGROUNDS_CombatModule_W7_WindwalkerMonk.PLAYERHP*1.0);bigvirmen.combat.hp.regenrate=750
				-- self.bigvirmen=bigvirmen
				
				-- local i
				-- for i=1,8,1 do
					-- local minion=TRAININGGROUNDS_Enemy_Tutorial_LargeVirmen.new()
					-- local angle=math.pi*2/8*(i)
					-- minion:setup(self.environment);
					-- minion.x=math.cos(angle)*150;minion.y=math.sin(angle)*150
					-- --minion.x=math.cos(i)*200;minion.y=math.sin(i)*200;
					-- minion.combat=TRAININGGROUNDS_CombatModule.new();
					-- minion.combat:setup(minion);minion.combat:SetMaximumAndCurrentHP(TRAININGGROUNDS_CombatModule_W7_WindwalkerMonk.PLAYERHP*0.5)
					-- --minion.combat.hp.visibleinnameplate=true;minion.combat:CreateNameplate()	
					-- self.minion=minion				
				-- end
				-- ------------------------------------------------------
				
				self.statetimer=2000	--!!!
				self.nextstate=self.states.TEXT

			elseif(self.state==self.states.TEXT)then		
				--!!!
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"- Sustained Workout -")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,self.talentstring)
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,self.hastestring)
				

				self.statetimer=2000
				self.nextstate=self.states.ZOOMIN
			elseif(self.state==self.states.ZOOMIN)then
				--!!!
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")
				--we want to stay zoomed out just enough that damage particles are still visible
				self.environment.camera.targetzoom=.85
				self.environment.camera:ChangeFocus(self.player)
				
				--self.guldan.combat.hp.visibleinnameplate=true
				--self.guldan.combat:CreateNameplate()
				--self.guldan.combat.hp.value=1
				----self.guldan.combat:CreateVisibleFrames()
				
				self.player.combat:CreateNameplate()
				
				self.statetimer=1000
				self.nextstate=self.states.MENU
				
			elseif(self.state==self.states.MENU)then						
				--!!!
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"This stage goes on forever.")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"To quit, press |cFFFFFF00Esc|cFFFFFFFF to clear your current target,")
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"then press |cFFFFFF00Esc|cFFFFFFFF again to open the menu.")
				self.statetimer=3000
				self.nextstate=self.states.END			
			elseif(self.state==self.states.END)then
				--!!!
				TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"");TRAININGGROUNDS_TypewriterMessage.QuickSetup(self,"|CLEAR")
				self.statetimer=nil
			end
			--self.environment.player.combat:CreateTutorialSpellButtons(3)
			--
		end
	end
	

	
	-- --TODO: debug skip
	if(_TRAININGGROUNDS.debug_autoscenario==true)then
		--if(self.state<self.states.PRESS1ATTACK)then
		--if(self.state<self.states.WAITFORZOOM)then
		--if(self.state<self.states.PRESS8ROLL)then
		-- if(self.state<self.states.SETUPPHASE2)then
			-- if(self.player~=nil)then
				-- self.player.x=0;self.player.y=0
			-- end
			-- self.statetimer=0
		-- end
		if(self.state<self.states.ZOOMIN)then
			self.statetimer=0
		end
		-- if(self.player~=nil and self.nextstate<self.states.SPEEDBOOST)then
			-- self.nextstate=self.states.SPEEDBOOST
		-- end
	end
	
	
	if(self.state<self.states.ZOOMIN)then
		self.environment.camera.targetzoom=.35
	end

	
end

