TRAININGGROUNDS_PlayerAnimations={}
TRAININGGROUNDS_PlayerAnimations.animtoidtable={}

TRAININGGROUNDS_PlayerAnimations.PRIORITIES={}
-- TODO: IDLE can still override MOVEMENT if the player stops moving
TRAININGGROUNDS_PlayerAnimations.PRIORITIES.IDLE=0
TRAININGGROUNDS_PlayerAnimations.PRIORITIES.EMOTE=1
TRAININGGROUNDS_PlayerAnimations.PRIORITIES.DAMAGE=2
TRAININGGROUNDS_PlayerAnimations.PRIORITIES.MOVEMENT=3
TRAININGGROUNDS_PlayerAnimations.PRIORITIES.JUMP=4
TRAININGGROUNDS_PlayerAnimations.PRIORITIES.CASTING=5
TRAININGGROUNDS_PlayerAnimations.PRIORITIES.ATTACK=6
-- TRAININGGROUNDS_PlayerAnimations.PRIORITIES.GUARDING=7
TRAININGGROUNDS_PlayerAnimations.PRIORITIES.DEAD=100

function TRAININGGROUNDS_PlayerAnimations.PriorityOverridesPriority(new,current)
	if(new>=TRAININGGROUNDS_PlayerAnimations.PRIORITIES.MOVEMENT)then
		if(new>=current)then return true end
	end
	if(current==TRAININGGROUNDS_PlayerAnimations.PRIORITIES.DAMAGE and current==new)then
		--TODO: damage shouldn't necessarily override damage, but we need FoF to work
		return true
	end
	if(current==TRAININGGROUNDS_PlayerAnimations.PRIORITIES.IDLE)then
		return true
	end
	--TODO: damage shouldn't override movement
	if(current==TRAININGGROUNDS_PlayerAnimations.PRIORITIES.EMOTE or current==TRAININGGROUNDS_PlayerAnimations.PRIORITIES.MOVEMENT)then
		if(new>=TRAININGGROUNDS_PlayerAnimations.PRIORITIES.EMOTE and new<=TRAININGGROUNDS_PlayerAnimations.PRIORITIES.MOVEMENT)then
			return true
		end
	end
	
	
	return false
end

function TRAININGGROUNDS_PlayerAnimations.setup()
	--
	-- TRAININGGROUNDS_PlayerAnimations.Create("StancelessDamage")
	-- TRAININGGROUNDS_PlayerAnimations.SetSomeCooldowns("StancelessDamage",1000,
	-- "Human",0,"Dwarf",0,"Dwarf",1,"NightElf",0,"Undead",0,"Tauren",1"Troll",1,"BloodElf",0,"Worgen",0)
	-- TRAININGGROUNDS_PlayerAnimations.SetSomeCooldowns("StancelessDamage",600,
	-- "Human",1,"Undead",1,"Tauren",0"Gnome",0,"Gnome",1,"Goblin",0,"Goblin",1,"Worgen",1)
	-- TRAININGGROUNDS_PlayerAnimations.SetSomeCooldowns("StancelessDamage",500,
	-- "Orc",0,"Orc",1,"NightElf",1,"Troll",0,"BloodElf",1,"Draenei",1)
	-- TRAININGGROUNDS_PlayerAnimations.SetSomeCooldowns("StancelessDamage",800,"Pandaren",0,"Pandaren",1)
	--
	
	--TODO: rename RaceSpecificAnimations?
	
	

	local EMOTE=TRAININGGROUNDS_PlayerAnimations.PRIORITIES.EMOTE
	local DAMAGE=TRAININGGROUNDS_PlayerAnimations.PRIORITIES.DAMAGE
	local MOVEMENT=TRAININGGROUNDS_PlayerAnimations.PRIORITIES.MOVEMENT
	local JUMP=TRAININGGROUNDS_PlayerAnimations.PRIORITIES.JUMP
	local CASTING=TRAININGGROUNDS_PlayerAnimations.PRIORITIES.CASTING
	local ATTACK=TRAININGGROUNDS_PlayerAnimations.PRIORITIES.ATTACK
	-- local GUARDING=TRAININGGROUNDS_PlayerAnimations.PRIORITIES.GUARDING
	local DEAD=TRAININGGROUNDS_PlayerAnimations.PRIORITIES.DEAD
	TRAININGGROUNDS_PlayerAnimations.Create("Idle",0,EMOTE)
		--																			Human		Orc			Dwarf		NightElf	Undead		Tauren		Gnome		Troll		Goblin		BloodElf	Draenei		Worgen		Pandaren
	TRAININGGROUNDS_PlayerAnimations.Create2("StancelessDamage", 8,DAMAGE,			1000,600,	500,500,	1000,1000,	1000,500,	1000,600,	600,1000,	600,600,	500,1000,	600,600,	1000,500,	600,500,	1000,600,	800,800)
	TRAININGGROUNDS_PlayerAnimations.Create2("StanceDamage",	9,	DAMAGE,			1000,1000,	500,500,	800,900,	600,500,	800,600,	800,900,	1000,1000,	500,900,	600,600,	600,500,	550,500,	550,500,	1000,1100)	
	TRAININGGROUNDS_PlayerAnimations.Create2("UnarmedPunch",	16,	ATTACK,			900,900,	900,900,	900,900,	900,900,	900,900,	900,900,	900,900,	900,900,	900,900,	1000,1000,	900,900,	1000,1000,	900,900)
	TRAININGGROUNDS_PlayerAnimations.Create2("MainhandSlash", 17,	ATTACK,			900,900,	900,900,	900,900,	900,900,	900,800,	900,900,	800,900,	900,900,	900,900,	1000,1000,	1200,900,	1200,900,	900,900)
	TRAININGGROUNDS_PlayerAnimations.Create2("TwoHandAttack1", 18,	ATTACK,			1200,1300,	1000,1400,	900,900,	800,900,	900,1300,	1300,1300,	900,900,	1400,1000,	1400,1400,	1300,1200,	1400,1300,	1300,1500,	1400,1400)
	TRAININGGROUNDS_PlayerAnimations.Create2("TwoHandAttack2", 19,	ATTACK,			1300,1500,	900,1300,	900,900,	1400,1400,	1400,1400,	1400,1400,	1400,1400,	1100,1400,	1100,1200,	1400,1300,	1000,1400,	1400,1300,	1500,1300)
	TRAININGGROUNDS_PlayerAnimations.Create2("Parry", 21,			DAMAGE,			900,800,	600,600,	900,800,	900,900,	900,800,	900,900,	900,900,	900,900,	900,900,	700,900,	1000,650,	900,900,	1000,900)
	TRAININGGROUNDS_PlayerAnimations.Create2("ShieldBlock", 22,		DAMAGE,			900,900,	600,600,	900,800,	900,900,	900,900,	900,900,	900,900,	900,800,	900,900,	900,800,	1000,900,	900,900,	1000,1000)
	TRAININGGROUNDS_PlayerAnimations.Create2("Dodge", 30,			DAMAGE,			900,950,	950,950,	950,950,	950,950,	950,950,	900,900,	900,950,	700,860,	900,900,	950,850,	950,900,	1000,1000,	1000,750)
	TRAININGGROUNDS_PlayerAnimations.Create2("Jump",37,				JUMP,			750,700,	750,750,	750,700,	750,750,	700,700,	700,750,	750,750,	700,750,	650,650,	750,700,	900,600,	700,700,	700,750)
	TRAININGGROUNDS_PlayerAnimations.Create2("LandOnGround",39,		JUMP,			900,1000,	1400,1300,	1300,1400,	1300,900,	1300,1300,	1400,1200,	1000,1000,	1000,1000,	1200,1200,	1000,1500,	900,850,	650,1000,	1400,1500)
									-- LandOnGround should use dual priority
	TRAININGGROUNDS_PlayerAnimations.Create2("FireGun",49,			ATTACK,			1000,1000,	1000,1000,	1000,1000,	1000,1000,	500,1000,	1000,1000,	900,900,	700,650,	1000,1000,	650,650,	650,650,	650,1000,	1000,1000)
	TRAININGGROUNDS_PlayerAnimations.Create2("FinishDirectedSpellcast",53,ATTACK,	1000,1000,	1000,1000,	1000,1000,	1000,1000,	1000,1000,	1000,1000,	1000,1000,	1000,1000,	1000,1000,	1000,1000,	1000,1000,	750,750,	1000,1000)
	TRAININGGROUNDS_PlayerAnimations.Create2("FinishUndirectedSpellcast",54,ATTACK, 1000,1000,	1000,1000,	1000,1000,	1000,1000,	1000,1000,	1000,800,	850,850,	850,1000,	850,650,	750,1000,	1000,1000,	900,900,	1000,1000)
	TRAININGGROUNDS_PlayerAnimations.Create2("OneHandFancyAttack",57,ATTACK,		900,1000,	1000,1000,	1000,1000,	900,1000,	900,900,	900,900,	900,900,	1000,900,	900,900,	1000,1100,	1300,1100,	900,1100,	1400,1400)
	TRAININGGROUNDS_PlayerAnimations.Create2("TwoHandAttack3",58,	ATTACK,			1400,1400,	1400,1200,	1400,1400,	1400,1200,	900,1400,	1400,1400,	1400,1400,	1400,1400,	1200,1200,	1400,1400,	1200,1200,	1400,1500,	1200,1400)
	TRAININGGROUNDS_PlayerAnimations.Create2("EatAtTable",61,		EMOTE,			2500,2500, 	2400,2400,	2000,3000,	2000,2400,	3300,2000,	2000,2000,	2600,2600,	2900,1500,	2500,2600,	3300,2000,	4200,1500,	3000,3000,	3000,3000)
	TRAININGGROUNDS_PlayerAnimations.Create2("EatWhileStanding",61,	EMOTE,			2250,2250,	2250,2250,	1750,2500,	1700,2100,	2700,1800,	1800,1800,	2300,2300,	2500,1200,	2100,2400,	2900,1600,	4200,1300,	2600,2700,	2500,2250)
	TRAININGGROUNDS_PlayerAnimations.Create2("Wave",67,				EMOTE,			2500,2500,	1500,1250,	1750,1750,	1250,1750,	1750,1250,	2250,2250,	2500,2750,	2500,2500,	3000,2500,	1250,2250,	2500,2500,	2500,2500,	2750,1750)
	TRAININGGROUNDS_PlayerAnimations.Create2("Laugh",70,			EMOTE,			3000,3250,	2750,3000,	2750,3000,	2250,2250,	3000,2750,	3250,3250,	3000,3250,	2750,2000,	6250,3250,	2750,2250,	3000,1900,	2750,2250,	6000,3300)
	TRAININGGROUNDS_PlayerAnimations.Create2("Roar",74,				EMOTE,			3000,3000,	3000,3000,	3000,3250,	2500,2000,	3000,2000,	2500,3000,	2250,2250,	2500,2000,	1750,3500,	1500,1500,	3250,2000,	4500,2400,	3000,2000)
	TRAININGGROUNDS_PlayerAnimations.Create2("Flex",82,				EMOTE,			2750,2750,	2750,2750,	2750,2750,	2750,2250,	4000,1750,	2750,2750,	2250,2250,	3000,2250,	6000,12000,	2900,3500,	2750,3000,	4500,2750,	3000,2000)
	TRAININGGROUNDS_PlayerAnimations.Create2("MainhandStab",85,		ATTACK,			900,900,	900,900,	900,900,	900,900,	900,900,	900,900,	900,900,	900,900,	900,900,	1000,1000,	900,900,	1000,1000,	1000,900)
	TRAININGGROUNDS_PlayerAnimations.Create2("OffhandSlash",87,		ATTACK,			900,900,	900,900,	900,900,	900,900,	900,900,	900,900,	900,900,	900,900,	900,900,	900,900,	1200,900,	1000,1000,	1000,900)
	TRAININGGROUNDS_PlayerAnimations.Create2("OffhandStab",88,		ATTACK,			900,900,	900,900,	900,900,	900,900,	900,900,	900,900,	900,900,	900,900,	900,900,	900,900,	900,1100,	900,1000,	1000,900)
	TRAININGGROUNDS_PlayerAnimations.Create2("Kick",95,				ATTACK,			900,900,	900,900,	900,900,	900,900,	900,900,	900,900,	1000,1000,	1300,1300,	800,800,	1000,900,	1100,900,	1000,1000,	1000,1000)
	--																				Human		Orc			Dwarf		NightElf	Undead		Tauren		Gnome		Troll		Goblin		BloodElf	Draenei		Worgen		Pandaren
	TRAININGGROUNDS_PlayerAnimations.Create2("ReloadGun",106,		EMOTE,			1000,500,	1000,650,	1000,500,	500,1000,	1000,950,	1000,950,	950,950,	600,650,	1000,1000,	1000,950,	950,1000,	1000,950,	1000,1000)
	TRAININGGROUNDS_PlayerAnimations.Create2("DualWieldFancyAttack",118,ATTACK,		900,1000,	900,900,	900,900,	1000,900,	900,900,	900,900,	1000,1000,	900,900,	1000,900,	1000,1200,	1000,1100,	1900,1900,	1500,1400)
	TRAININGGROUNDS_PlayerAnimations.Create2("Knockdown",121,		ATTACK,			1900,1900,	1900,1900,	1900,1900,	1900,1900,	2300,1900,	1900,1900,	1900,1900,	1900,1900,	1900,1900,	1500,1900,	1900,1900,	1900,1900,	1900,1900)	
	TRAININGGROUNDS_PlayerAnimations.Create2("BlackoutKick",662,	ATTACK,			1000,1000,	1000,1000,	1000,1000,	1000,1000,	1000,1000,	1000,1000,	1000,1000,	1000,1000,	800,800,	1000,1000,	1000,1000,	1000,1000,	1000,1000)
	TRAININGGROUNDS_PlayerAnimations.Create2("TigerPalm",670,		ATTACK,			1400,1400,	1400,1400,	1400,1400,	1400,1400,	1400,1400,	1400,1400,	1400,1400,	1400,1400,	1400,1400,	1400,1400,	1400,1400,	1400,1400,	1400,1400)
	TRAININGGROUNDS_PlayerAnimations.Create2("TouchOfDeath",672,	ATTACK,			900,900,	900,900,	900,900,	900,900,	900,900,	900,900,	900,900,	900,900,	800,900,	900,900,	900,900,	900,900,	900,900)
	--TODO: Chi Burst should be "casting" priority
		--(we manually override it with 2ndary priority in Spell_ChiBurst)
	TRAININGGROUNDS_PlayerAnimations.Create2("ChiBurst",680,	ATTACK,				1400,1400,	1400,1400,	1400,1300,	1400,1400,	1400,1400,	1400,1400,	1400,1400,	1400,1400,	1400,1400,	1400,1400,	1400,1400,	1400,1400,	1300,1300)
	TRAININGGROUNDS_PlayerAnimations.Create2("RisingSunKick",736,	ATTACK,			1000,1000,	1000,1000,	1000,1000,	1000,1000,	1000,1000,	1000,1000,	1000,1000,	1000,1000,	1000,1000,	1000,1000,	1000,1000,	1000,1000,	1000,1000)
	
	
	-- --																		Human		Orc			Dwarf		NightElf	Undead		Tauren		Gnome		Troll		Goblin		BloodElf	Draenei		Worgen		Pandaren
	-- TRAININGGROUNDS_PlayerAnimations.Create2("StancelessDamage", 8,			1000,600,	500,500,	1000,1000,	1000,500,	1000,600,	600,1000,	600,600,	500,1000,	600,600,	1000,500,	600,500,	1000,600,	800,800)
	-- TRAININGGROUNDS_PlayerAnimations.Create2("StanceDamage",	9,			1000,1000,	500,500,	800,900,	600,500,	800,600,	800,900,	1000,1000,	500,900,	600,600,	600,500,	550,500,	550,500,	1000,1100)	
	-- TRAININGGROUNDS_PlayerAnimations.Create2("UnarmedPunch",	16,			900,900,	900,900,	900,900,	900,900,	900,900,	900,900,	900,900,	900,900,	900,900,	1000,1000,	900,900,	1000,1000,	900,900)
	-- TRAININGGROUNDS_PlayerAnimations.Create2("MainhandSlash", 17,			900,900,	900,900,	900,900,	900,900,	900,800,	900,900,	800,900,	900,900,	900,900,	1000,1000,	1200,900,	1200,900,	900,900)
	-- TRAININGGROUNDS_PlayerAnimations.Create2("TwoHandAttack1", 18,			1200,1300,	1000,1400,	900,900,	800,900,	900,1300,	1300,1300,	900,900,	1400,1000,	1400,1400,	1300,1200,	1400,1300,	1300,1500,	1400,1400)
	-- TRAININGGROUNDS_PlayerAnimations.Create2("TwoHandAttack2", 19,			1300,1500,	900,1300,	900,900,	1400,1400,	1400,1400,	1400,1400,	1400,1400,	1100,1400,	1100,1200,	1400,1300,	1000,1400,	1400,1300,	1500,1300)
	-- TRAININGGROUNDS_PlayerAnimations.Create2("Parry", 21,					900,800,	600,600,	900,800,	900,900,	900,800,	900,900,	900,900,	900,900,	900,900,	700,900,	1000,650,	900,900,	1000,900)
	-- TRAININGGROUNDS_PlayerAnimations.Create2("ShieldBlock", 22,				900,900,	600,600,	900,800,	900,900,	900,900,	900,900,	900,900,	900,800,	900,900,	900,800,	1000,900,	900,900,	1000,1000)
	-- TRAININGGROUNDS_PlayerAnimations.Create2("Dodge", 30,					900,950,	950,950,	950,950,	950,950,	950,950,	900,900,	900,950,	700,860,	900,900,	950,850,	950,900,	1000,1000,	1000,750)
	-- TRAININGGROUNDS_PlayerAnimations.Create2("Jump",37,						750,700,	750,750,	750,700,	750,750,	700,700,	700,750,	750,750,	700,750,	650,650,	750,700,	900,600,	700,700,	700,750)
	-- TRAININGGROUNDS_PlayerAnimations.Create2("LandOnGround",39,				900,1000,	1400,1300,	1300,1400,	1300,900,	1300,1300,	1400,1200,	1000,1000,	1000,1000,	1200,1200,	1000,1500,	900,850,	650,1000,	1400,1500)
	-- TRAININGGROUNDS_PlayerAnimations.Create2("FireGun",49,					1000,1000,	1000,1000,	1000,1000,	1000,1000,	500,1000,	1000,1000,	900,900,	700,650,	1000,1000,	650,650,	650,650,	650,1000,	1000,1000)
	-- TRAININGGROUNDS_PlayerAnimations.Create2("FinishDirectedSpellcast",53,	1000,1000,	1000,1000,	1000,1000,	1000,1000,	1000,1000,	1000,1000,	1000,1000,	1000,1000,	1000,1000,	1000,1000,	1000,1000,	750,750,	1000,1000)
	-- TRAININGGROUNDS_PlayerAnimations.Create2("FinishUndirectedSpellcast",54,1000,1000,	1000,1000,	1000,1000,	1000,1000,	1000,1000,	1000,800,	850,850,	850,1000,	850,650,	750,1000,	1000,1000,	900,900,	1000,1000)
	-- TRAININGGROUNDS_PlayerAnimations.Create2("OneHandFancyAttack",57,		900,1000,	1000,1000,	1000,1000,	900,1000,	900,900,	900,900,	900,900,	1000,900,	900,900,	1000,1100,	1300,1100,	900,1100,	1400,1400)
	-- TRAININGGROUNDS_PlayerAnimations.Create2("TwoHandAttack3",58,			1400,1400,	1400,1200,	1400,1400,	1400,1200,	900,1400,	1400,1400,	1400,1400,	1400,1400,	1200,1200,	1400,1400,	1200,1200,	1400,1500,	1200,1400)
	-- TRAININGGROUNDS_PlayerAnimations.Create2("Wave",67,						2500,2500,	1500,1250,	1750,1750,	1250,1750,	1750,1250,	2250,2250,	2500,2750,	2500,2500,	3000,2500,	1250,2250,	2500,2500,	2500,2500,	2750,1750)
	-- TRAININGGROUNDS_PlayerAnimations.Create2("Laugh",70,					3000,3250,	2750,3000,	2750,3000,	2250,2250,	3000,2750,	3250,3250,	3000,3250,	2750,2000,	6250,3250,	2750,2250,	3000,1900,	2750,2250,	6000,3300)
	-- TRAININGGROUNDS_PlayerAnimations.Create2("Roar",74,						3000,3000,	3000,3000,	3000,3250,	2500,2000,	3000,2000,	2500,3000,	2250,2250,	2500,2000,	1750,3500,	1500,1500,	3250,2000,	4500,2400,	3000,2000)
	-- TRAININGGROUNDS_PlayerAnimations.Create2("Flex",82,						2750,2750,	2750,2750,	2750,2750,	2750,2250,	4000,1750,	2750,2750,	2250,2250,	3000,2250,	6000,12000,	2900,3500,	2750,3000,	4500,2750,	3000,2000)
	-- TRAININGGROUNDS_PlayerAnimations.Create2("MainhandStab",85,				900,900,	900,900,	900,900,	900,900,	900,900,	900,900,	900,900,	900,900,	900,900,	1000,1000,	900,900,	1000,1000,	1000,900)
	-- TRAININGGROUNDS_PlayerAnimations.Create2("OffhandSlash",87,				900,900,	900,900,	900,900,	900,900,	900,900,	900,900,	900,900,	900,900,	900,900,	900,900,	1200,900,	1000,1000,	1000,900)
	-- TRAININGGROUNDS_PlayerAnimations.Create2("OffhandStab",88,				900,900,	900,900,	900,900,	900,900,	900,900,	900,900,	900,900,	900,900,	900,900,	900,900,	900,1100,	900,1000,	1000,900)
	-- --																		Human		Orc			Dwarf		NightElf	Undead		Tauren		Gnome		Troll		Goblin		BloodElf	Draenei		Worgen		Pandaren
	-- TRAININGGROUNDS_PlayerAnimations.Create2("ReloadGun",106,				1000,500,	1000,650,	1000,500,	500,1000,	1000,950,	1000,950,	950,950,	600,650,	1000,1000,	1000,950,	950,1000,	1000,950,	1000,1000)
	-- TRAININGGROUNDS_PlayerAnimations.Create2("DualWieldFancyAttack",118,	900,1000,	900,900,	900,900,	1000,900,	900,900,	900,900,	1000,1000,	900,900,	1000,900,	1000,1200,	1000,1100,	1900,1900,	1500,1400)
	-- TRAININGGROUNDS_PlayerAnimations.Create2("Knockdown",121,				1900,1900,	1900,1900,	1900,1900,	1900,1900,	2300,1900,	1900,1900,	1900,1900,	1900,1900,	1900,1900,	1500,1900,	1900,1900,	1900,1900,	1900,1900)
	-- TRAININGGROUNDS_PlayerAnimations.Create2("BlackoutKick",662,			1000,1000,	1000,1000,	1000,1000,	1000,1000,	1000,1000,	1000,1000,	1000,1000,	1000,1000,	800,800,	1000,1000,	1000,1000,	1000,1000,	1000,1000)
	-- TRAININGGROUNDS_PlayerAnimations.Create2("TigerPalm",670,				1400,1400,	1400,1400,	1400,1400,	1400,1400,	1400,1400,	1400,1400,	1400,1400,	1400,1400,	1400,1400,	1400,1400,	1400,1400,	1400,1400,	1400,1400)
	-- TRAININGGROUNDS_PlayerAnimations.Create2("RisingSunKick",736,			1000,1000,	1000,1000,	1000,1000,	1000,1000,	1000,1000,	1000,1000,	1000,1000,	1000,1000,	1000,1000,	1000,1000,	1000,1000,	1000,1000,	1000,1000)
	
	
	
	
	
	
end

function TRAININGGROUNDS_PlayerAnimations.Create(animation,index,priority)
	TRAININGGROUNDS_PlayerAnimations.animtoidtable[animation]=index
	TRAININGGROUNDS_PlayerAnimations[index]={}
	for i,v in pairs(TRAININGGROUNDS_PlayerCharacterModelInfo.idtoracetable) do
		TRAININGGROUNDS_PlayerAnimations[index][i]={}
	end
	TRAININGGROUNDS_PlayerAnimations[index].priority=priority
end

function TRAININGGROUNDS_PlayerAnimations.Create2(animation, index, priority, ...)
	local male=0
	local female=1
	local arg={...}
	TRAININGGROUNDS_PlayerAnimations.Create(animation,index,priority)
	TRAININGGROUNDS_PlayerAnimations[index][TRAININGGROUNDS_PlayerCharacterModelInfo.racetoidtable["Human"]][male]=arg[1]
	TRAININGGROUNDS_PlayerAnimations[index][TRAININGGROUNDS_PlayerCharacterModelInfo.racetoidtable["Human"]][female]=arg[2]
	TRAININGGROUNDS_PlayerAnimations[index][TRAININGGROUNDS_PlayerCharacterModelInfo.racetoidtable["Orc"]][male]=arg[3]
	TRAININGGROUNDS_PlayerAnimations[index][TRAININGGROUNDS_PlayerCharacterModelInfo.racetoidtable["Orc"]][female]=arg[4]
	TRAININGGROUNDS_PlayerAnimations[index][TRAININGGROUNDS_PlayerCharacterModelInfo.racetoidtable["Dwarf"]][male]=arg[5]
	TRAININGGROUNDS_PlayerAnimations[index][TRAININGGROUNDS_PlayerCharacterModelInfo.racetoidtable["Dwarf"]][female]=arg[6]
	TRAININGGROUNDS_PlayerAnimations[index][TRAININGGROUNDS_PlayerCharacterModelInfo.racetoidtable["NightElf"]][male]=arg[7]
	TRAININGGROUNDS_PlayerAnimations[index][TRAININGGROUNDS_PlayerCharacterModelInfo.racetoidtable["NightElf"]][female]=arg[8]
	TRAININGGROUNDS_PlayerAnimations[index][TRAININGGROUNDS_PlayerCharacterModelInfo.racetoidtable["Undead"]][male]=arg[9]
	TRAININGGROUNDS_PlayerAnimations[index][TRAININGGROUNDS_PlayerCharacterModelInfo.racetoidtable["Undead"]][female]=arg[10]
	TRAININGGROUNDS_PlayerAnimations[index][TRAININGGROUNDS_PlayerCharacterModelInfo.racetoidtable["Tauren"]][male]=arg[11]
	TRAININGGROUNDS_PlayerAnimations[index][TRAININGGROUNDS_PlayerCharacterModelInfo.racetoidtable["Tauren"]][female]=arg[12]
	TRAININGGROUNDS_PlayerAnimations[index][TRAININGGROUNDS_PlayerCharacterModelInfo.racetoidtable["Gnome"]][male]=arg[13]
	TRAININGGROUNDS_PlayerAnimations[index][TRAININGGROUNDS_PlayerCharacterModelInfo.racetoidtable["Gnome"]][female]=arg[14]
	TRAININGGROUNDS_PlayerAnimations[index][TRAININGGROUNDS_PlayerCharacterModelInfo.racetoidtable["Troll"]][male]=arg[15]
	TRAININGGROUNDS_PlayerAnimations[index][TRAININGGROUNDS_PlayerCharacterModelInfo.racetoidtable["Troll"]][female]=arg[16]
	TRAININGGROUNDS_PlayerAnimations[index][TRAININGGROUNDS_PlayerCharacterModelInfo.racetoidtable["Goblin"]][male]=arg[17]
	TRAININGGROUNDS_PlayerAnimations[index][TRAININGGROUNDS_PlayerCharacterModelInfo.racetoidtable["Goblin"]][female]=arg[18]
	TRAININGGROUNDS_PlayerAnimations[index][TRAININGGROUNDS_PlayerCharacterModelInfo.racetoidtable["BloodElf"]][male]=arg[19]
	TRAININGGROUNDS_PlayerAnimations[index][TRAININGGROUNDS_PlayerCharacterModelInfo.racetoidtable["BloodElf"]][female]=arg[20]
	TRAININGGROUNDS_PlayerAnimations[index][TRAININGGROUNDS_PlayerCharacterModelInfo.racetoidtable["Draenei"]][male]=arg[21]
	TRAININGGROUNDS_PlayerAnimations[index][TRAININGGROUNDS_PlayerCharacterModelInfo.racetoidtable["Draenei"]][female]=arg[22]
	TRAININGGROUNDS_PlayerAnimations[index][TRAININGGROUNDS_PlayerCharacterModelInfo.racetoidtable["Worgen"]][male]=arg[23]
	TRAININGGROUNDS_PlayerAnimations[index][TRAININGGROUNDS_PlayerCharacterModelInfo.racetoidtable["Worgen"]][female]=arg[24]
	TRAININGGROUNDS_PlayerAnimations[index][TRAININGGROUNDS_PlayerCharacterModelInfo.racetoidtable["Pandaren"]][male]=arg[25]
	TRAININGGROUNDS_PlayerAnimations[index][TRAININGGROUNDS_PlayerCharacterModelInfo.racetoidtable["Pandaren"]][female]=arg[26]
	
	
end

function TRAININGGROUNDS_PlayerAnimations.SetAllCooldowns(animation,cooldown)
	local index=TRAININGGROUNDS_PlayerAnimations.animtoidtable[animation]
	for i,v in pairs(TRAININGGROUNDS_PlayerCharacterModelInfo.idtoracetable) do
		TRAININGGROUNDS_PlayerAnimations[index][i][0]=cooldown
		TRAININGGROUNDS_PlayerAnimations[index][i][1]=cooldown
	end
end

function TRAININGGROUNDS_PlayerAnimations.SetAllCooldowns2(animation,cooldown)
	local index=TRAININGGROUNDS_PlayerAnimations.animtoidtable[animation]

end

function TRAININGGROUNDS_PlayerAnimations.SetSomeCooldowns(animation,cooldown,...)	
	local index=TRAININGGROUNDS_PlayerAnimations.animtoidtable[animation]
	for i=1,#arg,2 do
		local race=TRAININGGROUNDS_PlayerCharacterModelInfo.racetoidtable[arg[i]]
		local sex=arg[i+1]
		TRAININGGROUNDS_PlayerAnimations[index][race][sex]=cooldown
		if(race==24 or race==25 or race==26)then
			TRAININGGROUNDS_PlayerAnimations[index][24][sex]=cooldown
			TRAININGGROUNDS_PlayerAnimations[index][25][sex]=cooldown
			TRAININGGROUNDS_PlayerAnimations[index][26][sex]=cooldown
		end		
	end
end



function TRAININGGROUNDS_PlayerAnimations.GetDetailsForNamedAnimation(name,race,sex)
	local index=TRAININGGROUNDS_PlayerAnimations.animtoidtable[name]
	local duration=TRAININGGROUNDS_PlayerAnimations[index][race][sex]
	local priority=TRAININGGROUNDS_PlayerAnimations[index].priority
	return index,duration,priority
end