TRAININGGROUNDS_Enemy_Tutorial_Critter_Rabbit = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_Enemy_Tutorial_Critter)

function TRAININGGROUNDS_Enemy_Tutorial_Critter_Rabbit:SetCustomInfo()
	TRAININGGROUNDS_Enemy_Tutorial_Critter.SetCustomInfo(self)
	self.airadius=nil
	self.aicooldownendtick=0
	self.aipoint=1	-- 0 right, 1 up, 2 left, 3 down
	self.aitargetx=nil
	self.aitargety=nil
end


function TRAININGGROUNDS_Enemy_Tutorial_Critter_Rabbit:SetModelSpecificInfo()
	-- Rabbit
	self.modelframe:SetDisplayInfo(328)
	self.modelinfo.sideviewoffsetY=29
	self.modelinfo.sideviewclickheight=60
	self.modelinfo.topviewoffsetY=20
	self.modelinfo.clickwidth=100
	self.modelinfo.offsetX=0
	self.modelinfo.gameplayscaleratio=1
end


function TRAININGGROUNDS_Enemy_Tutorial_Critter_Rabbit:step(elapsed)

	
	-- not only is 3/4 view calculation awkward,
	-- but rats tend to jump outside their clickbox during idle animation
	-- so we have to keep them moving
	TRAININGGROUNDS_Enemy_Tutorial_Critter.step(self,elapsed)
	
	-- Rabbit expects to start on the north side of the room.
	local player=self.environment.player
	if(self.airadius~=nil and player~=nil)then
		if(self.aicooldownendtick~=nil and self.aicooldownendtick<=self.environment.currenttime)then			
			local distancefromplayer=math.sqrt((player.x-self.x)*(player.x-self.x)+(player.y-self.y)*(player.y-self.y))
			if(distancefromplayer<500)then
				if(self.aipoint==0)then
					if(player.y<0)then self.aipoint=1 else self.aipoint=3 end
				elseif(self.aipoint==1)then
					if(player.x<0)then self.aipoint=0 else self.aipoint=2 end
				elseif(self.aipoint==2)then
					if(player.y<=0)then self.aipoint=1 else self.aipoint=3 end
				else
					if(player.x<=0)then self.aipoint=0 else self.aipoint=2 end
				end
				if(self.aipoint==0)then
					self.aitargetx=self.airadius;self.aitargety=0
				elseif(self.aipoint==1)then
					self.aitargetx=0;self.aitargety=self.airadius
				elseif(self.aipoint==2)then
					self.aitargetx=-self.airadius;self.aitargety=0
				elseif(self.aipoint==3)then
					self.aitargetx=0;self.aitargety=-self.airadius
				end
				self.aicooldownendtick=nil
			end		
		end
		if(self.aitargetx~=nil and self.aitargety~=nil)then
			local targetx,targety=self.aitargetx,self.aitargety
			local moveangle=math.atan2(targety-self.y,targetx-self.x)
			
			--TODO: don't directly set xspeed/yspeed
			--TODO: move to WoWCharacter
			local MOVESPEED=750
					
			local distancetotarget=math.sqrt((targetx-self.x)*(targetx-self.x)+(targety-self.y)*(targety-self.y))
			--print(distancetotarget)
			if(distancetotarget>10) then	

				self.xspeed=math.cos(moveangle)*MOVESPEED
				self.yspeed=math.sin(moveangle)*MOVESPEED
				--print(self.xspeed,self.yspeed)
				
				self.movevectorxx=self.xspeed
				self.movevectoryy=self.yspeed
				self.movespeed=math.sqrt((self.xspeed*self.xspeed)+(self.yspeed*self.yspeed))
				local turnspeed=1
				local movevectorfacing=math.atan2(self.movevectorxx,-self.movevectoryy)
				self:changeFacing(movevectorfacing,elapsed,turnspeed)
			else
				self.x=self.aitargetx
				self.y=self.aitargety
				self.xspeed=0
				self.yspeed=0
				self.movevectorxx=0
				self.movevectoryy=0
				self.movespeed=0
				self.aitargetx=nil
				self.aitargety=nil
				self.aicooldownendtick=self.environment.currenttime+1
			end
		end
	
	end
	
	
	
	
	
	
	
	-- -- The tutorial rabbit is programmed to flee the player if its AI is switched on
	-- -- It moves in a circle 90 degrees at a time
	-- -- Brief cooldown period to let the player catch up if they're using a speed boost

	-- local player=self.environment.player
	
	-- if(self.aitargetangle~=nil)then
		-- local angle=math.atan2(self.y,self.x)
		-- angle=math.fmod(angle,math.pi*2)
		-- local target=math.fmod(self.aitargetangle,math.pi*2)
		-- if(math.abs(angle-target)<0.2)then
			
		-- end
		
	-- end
		
	-- if(self.aiflee~=nil and player~=nil)then
		-- --TODO: does lua use atan2(y,x), or should it be atan2(x,y)?
		
		-- local angle=math.atan2(self.y,self.x)
		-- if(angle<0)then angle=angle+6.28 end
		-- local maxradius=900
		-- local minradius=100
		-- --
		-- local playerradius=math.sqrt(player.x*player.x+player.y*player.y)
		
		-- -- find target position based on player's position
		-- local playerangle=math.atan2(player.y,player.x)
		-- if(playerangle<0)then playerangle=playerangle+6.28 end
		-- local targetangle=playerangle+3.14
		-- if(targetangle>6.28)then targetangle=targetangle-6.28 end
		
		
		-- if(angle<0)then angle=angle+6.28 end
		-- local angledifference=math.abs(targetangle-angle)	
		-- local angledifference2=angledifference
		-- if(angledifference2>3.14)then angledifference2=angledifference2-6.28 end
		-- -- must be at least 0.2 or distance to target won't be >50
		-- if(math.abs(angledifference2)>0.2)then
						
			-- local direction=signum(targetangle-angle)
			-- if(angledifference>3.14)then direction=-direction end
			
			-- angle=angle+0.2*direction
		-- end
		
		
		-- local distancefromplayer=math.sqrt((player.x-self.x)*(player.x-self.x)+(player.y-self.y)*(player.y-self.y))
		-- --if(self.airadius<playerradius+100)then self.airadius=playerradius+100 end
		
		-- if(distancefromplayer>400)then self.airadius=self.airadius-500*elapsed end
		-- if(distancefromplayer<300)then self.airadius=self.airadius+500*elapsed end
		-- if(self.airadius>maxradius)then self.airadius=maxradius end
		-- if(self.airadius<minradius)then self.airadius=minradius end
		
		-- -- if(distancefromplayer<self.airadius)then
			-- -- self.airadius=self.airadius+1			
			-- -- if(self.airadius>maxradius)then self.airadius=maxradius end
		-- -- elseif(distancefromplayer>500)then
			-- -- self.airadius=self.airadius-1
			-- -- if(self.airadius<minradius)then self.airadius=minradius end
		-- -- end
		
		-- local radius=self.airadius
		
		-- local targetx,targety=self.airadius*math.cos(angle),self.airadius*math.sin(angle)
		-- local moveangle=math.atan2(targety-self.y,targetx-self.x)
		
		-- --TODO: don't directly set xspeed/yspeed
		-- --TODO: move to WoWCharacter
		-- local MOVESPEED=500
				
		-- local distancetotarget=math.sqrt((targetx-self.x)*(targetx-self.x)+(targety-self.y)*(targety-self.y))
		-- --print(distancetotarget)
		-- if(distancetotarget>50) then	

			-- self.xspeed=math.cos(moveangle)*MOVESPEED
			-- self.yspeed=math.sin(moveangle)*MOVESPEED
			-- --print(self.xspeed,self.yspeed)
			
			-- self.movevectorxx=self.xspeed
			-- self.movevectoryy=self.yspeed
			-- self.movespeed=math.sqrt((self.xspeed*self.xspeed)+(self.yspeed*self.yspeed))
			-- local turnspeed=1
			-- local movevectorfacing=math.atan2(self.movevectorxx,-self.movevectoryy*self.environment.camera.ystretch)	
			-- self:changeFacing(movevectorfacing,elapsed,turnspeed)
		-- else
			-- self.xspeed=0
			-- self.yspeed=0
			-- self.movevectorxx=0
			-- self.movevectoryy=0
		-- end
	-- end
	
end