TRAININGGROUNDS_FakePlayerCharacter = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_WoWCharacter)

function TRAININGGROUNDS_FakePlayerCharacter:setup(environment,race,sex)
	-- If race/sex are set to nil here, we'll correct them in modelspecificinfo.
	self.displayedrace=race
	self.displayedsex=sex
	-- Same as displayedrace, except if race/sex matches the player's WoW character, these are nil.
	self.customrace=race
	self.customsex=sex	
	self.titlescreensequence=nil
	self.currenttitlescreenaction=nil
	self.currenttitlescreenactionstart=nil	
	self.currenttitlescreenactionfirstframe=false
	TRAININGGROUNDS_WoWCharacter.setup(self,environment)	
end

function TRAININGGROUNDS_FakePlayerCharacter:SetModelSpecificInfo()
	-- do not call super
	self.modelinfo={}
	self.modelinfo={}

	self.currentanimation=0
	self.currentfacing=0
	
	local modelinfo
	modelinfo,self.displayedrace,self.displayedsex=TRAININGGROUNDS_PlayerCharacterModelInfo.SetModelframeToPlayerAndReturnModelInfo(self.modelframe)
	--print("FakePlayerCharacter model "..tostring(race)..", "..tostring(sex))
	--print("FakePlayerCharacter custom "..tostring(self.customrace)..", "..tostring(self.customsex))
	self.modelinfo=modelinfo
	if(self.customrace~=nil)then
		self.displayedrace=self.customrace
	end
	if(self.customsex~=nil)then
		self.displayedsex=self.customsex
	end
	--print("FakePlayerCharacter final "..tostring(self.customrace)..", "..tostring(self.customsex))
	-- send race and sex to SetEquipmentInfo
	self:SetEquipmentInfo(self.displayedrace,self.displayedsex)
	-- don't send race/sex to AttemptSetCustomApperance unless they've been customized
	if(self.customrace~=nil or self.customsex~=nil or self.equipment~=nil) then
		self.modelinfo=TRAININGGROUNDS_PlayerCharacterModelInfo.AttemptSetCustomAppearanceAndReturnModelInfo(self.modelframe,self.equipment,self.customrace,self.customsex)
	end		
end

-- function TRAININGGROUNDS_FakePlayerCharacter:SetNameplate()
	-- TRAININGGROUNDS_WoWCharacter.SetNameplate(self)
	-- self.nameplate.border:Hide()
	-- self.nameplate.fill:Hide()
	-- self.nameplate.hurt:Hide()
-- end


	
function TRAININGGROUNDS_FakePlayerCharacter:ApplyHalfDisabledEffect()
	--!!!
	--self.frame:SetAlpha(0.25)
end

function TRAININGGROUNDS_FakePlayerCharacter:ApplyDisabledEffect()
	--(enabled[,omni,dirX,dirY,dirZ,ambIntensity[,ambR,ambG,ambB [,dirIntensity[,dirR,dirG,dirB]]]])
	--!!!
	--self.modelframe:SetLight(1,0,-1,0,0,0)
end

function TRAININGGROUNDS_FakePlayerCharacter:step(elapsed)
	TRAININGGROUNDS_WoWCharacter.step(self,elapsed)

	--TODO: move to FakePlayerCharacterTitleAnimations.lua
	local animationloop=true
	while(animationloop==true)do
		animationloop=false
		if(self.titlescreensequence~=nil)then		
			if(self.currenttitlescreenaction==nil)then			
				self.currenttitlescreenaction=self.titlescreensequence[1]
				tremove(self.titlescreensequence,1)
				self.currenttitlescreenactionstart=self.environment.currenttime
				self.currenttitlescreenactionfirstframe=true
			end
		end
		if(self.currenttitlescreenaction~=nil)then
			local actiontype=self.currenttitlescreenaction[1]
			local actionamount=self.currenttitlescreenaction[2]
			local actiontime=self.currenttitlescreenaction[3]
			local action4=self.currenttitlescreenaction[4]
			if(actiontype=="disarm")then
				self.modelframe:UndressSlot(TRAININGGROUNDS_PlayerCharacterModelInfo.EQUIPMENTSLOTID["MainHandSlot"])
				self.modelframe:UndressSlot(TRAININGGROUNDS_PlayerCharacterModelInfo.EQUIPMENTSLOTID["SecondaryHandSlot"])
			elseif(actiontype=="fadeanim")then
				self.modelframe:SetAlpha(0)
				if(self.currenttitlescreenactionfirstframe==true)then
					self.modelframe:SetAnimation(actionamount)
				end
			elseif(actiontype=="fadein")then
				local alpha=(self.environment.currenttime-self.currenttitlescreenactionstart)/actiontime
				if(alpha>1)then alpha=1 end	
				self.modelframe:SetAlpha(alpha)
			elseif(actiontype=="stealthfadein")then
				local alpha=(self.environment.currenttime-self.currenttitlescreenactionstart)/actiontime
				alpha=alpha*0.5
				if(alpha>0.5)then alpha=0.5 end	
				self.modelframe:SetAlpha(alpha)				
			elseif(actiontype=="idle")then			
				-- use "idle" to stand still while character is already in anim 0
			elseif(actiontype=="anim")then			
				if(self.currenttitlescreenactionfirstframe==true)then
					self.modelframe:SetAnimation(actionamount)
				end
			elseif(actiontype=="seq")then			
				--if(self.currenttitlescreenactionfirstframe==true)then
					self.modelframe:SetSequenceTime(actionamount,(self.environment.currenttime-self.currenttitlescreenactionstart)*action4)
				--end			
			elseif(actiontype=="fadeout")then
				local alpha=1-(self.environment.currenttime-self.currenttitlescreenactionstart)/actiontime
				if(alpha>1)then alpha=1 end			
				self.modelframe:SetAlpha(alpha)
			elseif(actiontype=="stealthfadeout")then
				local alpha=1-(self.environment.currenttime-self.currenttitlescreenactionstart)/actiontime
				alpha=alpha*0.5
				if(alpha>0.5)then alpha=0.5 end	
				self.modelframe:SetAlpha(alpha)						
			elseif(actiontype=="die")then
				self:die()
			end	
			self.currenttitlescreenactionfirstframe=false
			if(self.environment.currenttime>=self.currenttitlescreenactionstart+actiontime)then
				self.currenttitlescreenaction=nil			
			end
			if(actiontime==0)then
				animationloop=true
			end
		end
	end

end

function TRAININGGROUNDS_FakePlayerCharacter:SetEquipmentInfo(raceid,sex)
	-- TODO: move to wowcharacter?	
end

function TRAININGGROUNDS_FakePlayerCharacter:SetRandomTitleScreenAnimationSequence(enablesillysequences)
	-- don't override this one -- override SetClassSpecificTitleScreenAnimationSequence instead

	-- TODO: use portraitscale for titlescreen instead of gameplayscale
	
	--TODO LATER: hook up these animations with the character movement system
	--TODO LATER: mage/druid blink
	--TODO LATER: druid shapeshift animations
	--TODO LATER: priest shadowform animation
	
	self.modelframe:SetAlpha(0)
	
	-- let's say ... 1/16 chance to see a silly bonus sequence.
	-- MenuController_TitleScreen determines whether silly things are enabled,
	-- which as of the time of this writing is starting with the 3rd sequence.
	--self.titlescreensequence=FakePlayerCharacterTitleAnimations.UndirectedSpellcast()
	
	if(enablesillysequences==true and random()<0.0625) then
		--TODO LATER: is this just storing a function reference, or is it copying the entire function?
		local sillies={
			FakePlayerCharacterTitleAnimations.BladestormKnockdown
			, FakePlayerCharacterTitleAnimations.SwimForward
			, FakePlayerCharacterTitleAnimations.FlexDie
			, FakePlayerCharacterTitleAnimations.MonkRoll
			, FakePlayerCharacterTitleAnimations.Dance
		}		
		if(self:Is2HOnTitleScreen())then
			tinsert(sillies,FakePlayerCharacterTitleAnimations.HunterGunshot)
		end
		--TODO LATER: maybe silly version of monk roll ends in stunned/dizzy
		local i=random(#sillies)
		self.titlescreensequence=sillies[i](self)
	else
		local sequences=self:GetClassSpecificTitleScreenAnimationSequences()		
		local i=random(#sequences)
		self.titlescreensequence=sequences[i](self)
		
	end	
	
	----!!!
	--self.titlescreensequence=FakePlayerCharacterTitleAnimations.TankDodge()
	
	tinsert(self.titlescreensequence,{"die",nil,500})
end

function TRAININGGROUNDS_FakePlayerCharacter:GetClassSpecificTitleScreenAnimationSequences()
	-- override, don't call super
	return {FakePlayerCharacterTitleAnimations.Dance}
end

-- TODO: rename to CanUseSillyHunterAnimation?
-- (hunters return false)
function TRAININGGROUNDS_FakePlayerCharacter:Is2HOnTitleScreen()
	-- override
	return false
end



function TRAININGGROUNDS_FakePlayerCharacter.CreateRandomFakePlayerCharacter()

	--if(true)then return TRAININGGROUNDS_FakePlayerCharacter_Warrior.new() end

	local i=random(1,12)
	local class=TRAININGGROUNDS_FakePlayerCharacter.GetClassByIndex(i)
	
	return class.new()
end

function TRAININGGROUNDS_FakePlayerCharacter.GetClassByIndex(i)
	local class
	if(i==1)then
		class=TRAININGGROUNDS_FakePlayerCharacter_DeathKnight
	elseif(i==2)then
		class=TRAININGGROUNDS_FakePlayerCharacter_DemonHunter
	elseif(i==3)then
		class=TRAININGGROUNDS_FakePlayerCharacter_Druid
	elseif(i==4)then
		class=TRAININGGROUNDS_FakePlayerCharacter_Hunter
	elseif(i==5)then
		class=TRAININGGROUNDS_FakePlayerCharacter_Mage
	elseif(i==6)then
		class=TRAININGGROUNDS_FakePlayerCharacter_Monk
	elseif(i==7)then
		class=TRAININGGROUNDS_FakePlayerCharacter_Paladin
	elseif(i==8)then
		class=TRAININGGROUNDS_FakePlayerCharacter_Priest
	elseif(i==9)then
		class=TRAININGGROUNDS_FakePlayerCharacter_Rogue
	elseif(i==10)then
		class=TRAININGGROUNDS_FakePlayerCharacter_Shaman
	elseif(i==11)then
		class=TRAININGGROUNDS_FakePlayerCharacter_Warlock
	else
		class=TRAININGGROUNDS_FakePlayerCharacter_Warrior
	end
	return class
end