TRAININGGROUNDS_Particle_ChiOrbit = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_Particle)

function TRAININGGROUNDS_Particle_ChiOrbit:SetCustomInfo()
	TRAININGGROUNDS_Particle.SetCustomInfo(self)
	
	--self.hitdetectfrequency=250
	self.hitdetectfrequency=100 	-- careful, hit detection is o(n^2)
	self.nexthitdetecttick=self.environment.currenttime+self.hitdetectfrequency
	
	self.orbitradius=0
	self.maxorbitradius=200
end

function TRAININGGROUNDS_Particle_ChiOrbit:SetModelSpecificInfo()
	self.modelframe:SetModel(0)
	self.modelframe:SetModel("SPELLS\\Monk_ChiBlast_Missile.M2")	
	self.modelframe:SetWidth(50)
	self.modelframe:SetHeight(50)
	--self.modelframe:SetPosition(-4,0,2.6)	-- for normal window
	--self.modelframe:SetPosition(0,0,0)
	self.modelinfo.sideviewoffsetY=100
	self.modelinfo.sideviewclickheight=0
	self.modelinfo.topviewoffsetY=100
	self.modelinfo.clickwidth=0
	self.modelinfo.offsetX=0
	self.modelinfo.gameplayscaleratio=0.075
end

function TRAININGGROUNDS_Particle_ChiOrbit:step(elapsed)
	TRAININGGROUNDS_Particle.step(self,elapsed)
	
	if(self.character.dead==true)then
		if(self.expirytime==nil)then
			self.expirytime=self.environment.currenttime+250
		end		
	end
	
	self.orbitradius=self.orbitradius+(self.maxorbitradius*0.2)*elapsed
	if(self.orbitradius>=self.maxorbitradius)then
		self.orbitradius=self.maxorbitradius
	end
	
	--print("ChiOrbit ",self.buff,self.buff.angle)
	local angle=self.buff.angle+((self.slot-1)*math.pi/2)
	angle=angle+(self.character.currentfacing-math.pi/2)
	--self.orbitradius=self.maxorbitradius --!!!
	--character is set by spell_chiorbit as a convenience
	self.x=self.character.x+self.orbitradius*math.cos(angle)
	self.y=self.character.y+self.orbitradius*math.sin(angle)
	
	
	-- beginning of the line segment for line-circle hit detection.
	-- after we run hit detection, the beginning of the line segment moves up to projectile's current position.
	if(self.xsegmentstart==nil)then
		self.xsegmentstart=self.x
		self.ysegmentstart=self.y
	end
	
	if(self.expirytime==nil )then
		if(self.environment.currenttime>=self.nexthitdetecttick)then
			self.nexthitdetecttick=self.environment.currenttime+self.hitdetectfrequency
			
			-- spell is set via Buff_ChiOrbit
			local radius=0 
			local objlist=self.buff.combat.character.environment:LineCircleCollisionList(self.xsegmentstart,self.ysegmentstart,self.x,self.y,radius)
			self.xsegmentstart=self.x;self.ysegmentstart=self.y
			
			if(self.orbitradius>=self.maxorbitradius) then			
				local wowlist={}
				local i
				for i=1,#objlist,1 do
					local obj=objlist[i]
					if(obj.combat~=nil)then
						--TODO: not isa
						if(obj:isa(TRAININGGROUNDS_Enemy))then				
							--TODO: standardize "is this a valid target for non-piercing untargeted projectile" check
							if(obj.deadingame~=true)then
								tinsert(wowlist,obj)
							end
						end
					end
				end			
				if(self.buff~=nil)then				
					if(#wowlist>=1)then						
						local obj=wowlist[1]
						self.buff:OnProjectileHit(self.environment.currenttime,obj)
						self.expirytime=self.environment.currenttime+250	
					end
				end
			end
		end
	else
		local a=(self.expirytime-self.environment.currenttime)/250
		self.modelframe:SetAlpha(a)
	end


	
	
	
end