TRAININGGROUNDS_WoWCharacter = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_GameObject)

-- TRAININGGROUNDS_WoWCharacter = {}
-- TRAININGGROUNDS_WoWCharacter.__index = TRAININGGROUNDS_WoWCharacter

-- function TRAININGGROUNDS_WoWCharacter:new()
	-- local self={}
	-- setmetatable(self, TRAININGGROUNDS_WoWCharacter)	

	-- return self
-- end

function TRAININGGROUNDS_WoWCharacter:setup(game)	
	TRAININGGROUNDS_GameObject.setup(self,game)
	
	--print("Setup: ",self)
	
	tinsert(game.newwowcharacters,self)
end

function TRAININGGROUNDS_WoWCharacter:SetCustomInfo()
	TRAININGGROUNDS_GameObject.SetCustomInfo(self)
	

	
	self.x=0
	self.y=0
	self.z=0		-- height
	self.xspeed=0
	self.yspeed=0
	self.zspeed=0
	
	self.prevx=0
	self.prevy=0
	self.prevz=0
	
	
	self.jumpspeed=100*4
	self.jumpimpetus=0	--TODO: implement jump impetus?
	self.gravity=-300*4
	
	self.jumpanimationsequence=37
	self.jumpanimationduration=600
	self.endjumpanimationsequence=39
	self.endjumpanimationduration=1000	
	
	self.idleanimindex=0
	self.combatstanceidleanimindex=678
	

	
	
	
	-- modelsize varies by model.  default 400
	-- (numbers are chosen to make model "look good" at zoom==1.0)
	self.modelsize=400	

	-- modelscale is used to keep the model from clipping against the edge of the frame
	-- modelscale should never be higher than 0.5
	self.modelscale=0.5
	
	-- changing modelscale *shouldn't* affect the appearance of the model, but it's buggy


	
	
	--TODO: modeloffsets should be aligned with middle of targeting circle
	-- Adjust these values in SetAppearance to line up the model with the center of the character's targeting circle.	
	-- if you are trying to adjust the default modeloffset, remember that WoWCharacter.lua overrides itself during SetAppearance
	self.modeloffsetX=0		--these offsets will be scaled up or down with modelscale accordingly
	self.modeloffsetY=0		
	
	-- this will be set to true whenever we need to resize the object
	-- ...however, we currently also check Camera.zoomchanged
	-- TODO: when camera zoom changes, it instead sets forceresizeframe for all objects in scene 
	self.forceresizeframe=false

	
	self.currentanimation=0
	self.currentfacing=0
	


	
	self.spellbook={}
	
	self.attackanimation=0
	self.attackanimationendtick=nil
	self.combatstanceendtick=0
	
	self.animationpriority=0
	self.animationendtick=0
	--some animations change priority halfway through the animation
		-- the system is built with the expectation that priority will only ever decrease.
			-- weird things might happen if priority increases.
	self.animationnextpriority=nil
	self.animationchangeprioritytick=nil
	
	self.animationindex_superfastrun=143
	self.animationindex_fastrun=143
	self.animationindex_run=5
	self.animationindex_walk=4
	
	--self.snapfacing=false
	self.snapfacingendtick=0
	self.snapfacingtarget=nil
	
	--player can change facing during jumps, but not during rolls
	self.lockfacingendtick=0
	
	self.movevectorxx=0
	self.movevectoryy=0
	self.movespeed=0
	--self.movevectoryy=1
	self.movevectorangle=0
	self.forcedmovexx=nil
	self.forcedmoveyy=nil


	-- to change a player race's model, change gameplayscaleratio + portraitscaleratio in PlayerCharacterModelInfo
	
	-- to resize a model during gameplay or on menu without changing camera zoom, call SetExtraScale
	-- don't change extrascale directly, else frame might not be resized correctly
	self.extrascale=1
	

	--nameplates are created in SetAppearance
end

function TRAININGGROUNDS_WoWCharacter:SetClickability()

	self.clickable=true
	
	-- TODO: move to SetClickarea function
	self.clickarea={}	
	self.clickarea.x=0	
	
	self:SetClickarea()
				
end



function TRAININGGROUNDS_WoWCharacter:SetFrame()
	-- do not call super

	--self.frame=TRAININGGROUNDS_ReusableModelFrames.getFrame()	
	self.frame=TRAININGGROUNDS_ReusableFrames.getFrame()	
	self.modelframe=TRAININGGROUNDS_ReusableModelFrames.getFrame()	
	
end


function TRAININGGROUNDS_WoWCharacter:SetAppearance()

	-- do not call super; frame doesn't like when displayinfo changes
	
	self.frame:Show() -- required to set model info and enable custom camera
	self.modelframe:Show() -- required to set model info and enable custom camera
	self.modelframe:SetParent(self.frame)
	
	self.alignment="CENTER"
		
	self.modelinfo={}
	self:SetModelSpecificInfo()
	self:CalculateModelOffsets()
	self.modelframe:SetCustomCamera(1)

	self:SetOrientation(TRAININGGROUNDS_Game.TEMP_DISTANCE,0,self.environment.camera.modelangle)
	self:SetAdjustedFacing(self.currentfacing)
	
	if(_TRAININGGROUNDS.debug_show3dframes==true)then
		self.modelframe.texture:Show()
	end
end

function TRAININGGROUNDS_WoWCharacter:SetFrameSize()
	local camera=self.environment.camera
	--TODO: move resolutioncorrection to global function
	local resolutioncorrection=((GetScreenWidth()/GetScreenHeight())/(800.0/600.0))   --/self.parentframe:GetScale()
	local gamescale=self.environment.game.frame:GetScale()
	--print("TRAININGGROUNDS_WoWCharacter:SetFrameSize: resolution correction is "..resolutioncorrection)
	--resolutioncorrection=1	
	--local totalsize=self.modelsize*self.modelscale*resolutioncorrection*scalecorrection*camera.zoom
	--local totalsize=self.modelsize/self.modelscale*resolutioncorrection*gamescale*camera.zoom
	local totalsize=self.modelsize/self.modelscale*resolutioncorrection/gamescale*camera.zoom
	-- TODO: check with current environment whether to use gameplayscaleratio or gameplayscaleratio!
	totalsize=totalsize*self.modelinfo.gameplayscaleratio*self.extrascale
	
	
	self.frame:SetWidth(totalsize);self.frame:SetHeight(totalsize)
	self.modelframe:SetWidth(totalsize);self.modelframe:SetHeight(totalsize)	
	
	self:SetDebugVisibleClickareaFrame();
	
	self.modelframe:SetModelScale(self.modelscale)
	
	-- if(self:isa(TRAININGGROUNDS_Enemy_W7_ProvingGrounds_IllusionaryGuardian))then
		-- print("Guardian size: ",totalsize)
		-- print("Modelscale: ",self.modelscale)		
	-- end	
end


function TRAININGGROUNDS_WoWCharacter:SetModelSpecificInfo()

	-- override
	-- do not call super when overriding
	
	-- Large Illusionary Slayer
	self.modelframe:SetDisplayInfo(48897)
	self.modelframe:SetAlpha(0.66)	

	-- TODO: determine modelinfo for large slayer
	

	-- self.frame:SetDisplayInfo(384) 	-- Hogger
end

function TRAININGGROUNDS_WoWCharacter:CalculateModelOffsets()
	local gamescale=self.environment.game.frame:GetScale()


	local modelinfo=self.modelinfo	
	local modelangle=self.environment.camera.modelangle
	
	local adjustedoffset
	-- this method works okay for some races/sexes, and not so well for others
	-- ...but it's the best method we've found so far
	adjustedoffset=modelinfo.topviewoffsetY*-math.sin(modelangle)+modelinfo.sideviewoffsetY*math.cos(modelangle)
	
	-- -- this method doesn't seem to work at all for some races/sexes
	-- -- adjustedoffset=modelinfo.topviewoffsetY*(-modelangle/(math.pi*.5))+modelinfo.sideviewoffsetY*(1-(-modelangle/(math.pi*.5)))
	
	--self.modeloffsetY=modelinfo.sideviewoffsetY
	self.modeloffsetY=adjustedoffset/self.modelscale/gamescale/2
	
	self.modeloffsetX=modelinfo.offsetX
end


function TRAININGGROUNDS_WoWCharacter:SetClickarea()
	-- Set this once after creating the character.  You do not need to set it again after camerazoom changes.
	-- However, if the nameplate changes, you'll need to set it again.
	
	-- Clickarea does NOT include character resizes (including class/sex ratio resizes)
	-- because character resizes are treated as an extension of camera zoom.
	-- Must detect resize while calculating click detection
	-- and when drawing the debug visible clickareas.
	local modelinfo=self.modelinfo

	-- intuitively we would place clickarea.y at half of the modelwidth amount
	-- ...but this doesn't quite work.  model is vertically offcenter.
	-- here is a cheap, unproven workaround.
	--TODO: rename foo
	--local foo=0.25+0.25*math.cos(self.environment.camera.modelangle)
	--self.clickarea.y=-foo*modelinfo.width*(-math.sin(self.environment.camera.modelangle))
	
	-- TODO: ask environment whether to use portrait ratio or gameplay ratio
	
	
	self.clickarea.y=-.5*modelinfo.clickwidth*(-math.sin(self.environment.camera.modelangle))
	self.clickarea.width=modelinfo.clickwidth
	self.clickarea.height=self:CalculateClickareaHeight()

	-- TODO: add nameplate height to clickarea
	--self.clickarea.height=self.clickarea.height+TRAININGGROUNDS_Nameplate.NAMEPLATE_HEIGHT
end

function TRAININGGROUNDS_WoWCharacter:CalculateClickareaHeight()
		local height=self:GetClickareaHeightWithoutNameplate()
		if(TRAININGGROUNDS_CLICKAREA_INCLUDES_NAMEPLATE==true)then
			if(self.combat~=nil and self.combat.nameplate~=nil)then
				height=height+self.combat.nameplate:GetNameplateHeight()
			end
		end
		
		return height
end

function TRAININGGROUNDS_WoWCharacter:GetClickareaHeightWithoutNameplate()
		local modelinfo=self.modelinfo
		--TODO: ask environment which ratio to use
		--local ratio=self.modelinfo.gameplayscaleratio
		local height
		height=(modelinfo.sideviewclickheight)*(math.cos(self.environment.camera.modelangle))
							+(modelinfo.clickwidth)*(-math.sin(self.environment.camera.modelangle))		
		--height=height*ratio			
		return height
end


-- -- This function calculates what clickarea height would be as if the model weren't resized
-- -- (this is useful to reposition the model's feet)
-- function TRAININGGROUNDS_WoWCharacter:CalculateClickareaHeightWithoutRatio()
		-- local modelinfo=self.modelinfo
		-- local height
		-- height=(modelinfo.sideviewclickheight)*(math.cos(self.environment.camera.modelangle))
							-- +(modelinfo.clickwidth)*(-math.sin(self.environment.camera.modelangle))			
		-- return height
-- end


function TRAININGGROUNDS_WoWCharacter:SetShadowDetails()
	self.shadow=true
end


-- function TRAININGGROUNDS_WoWCharacter:SetNameplate()
	-- -- override
	-- -- do not call super when overriding
	-- --self.nameplate=TRAININGGROUNDS_Nameplate.new()
	-- --self.nameplate:setup(self,20,self.modelinfo.visibleheight)
-- end


function TRAININGGROUNDS_WoWCharacter:SetExtraScale(extrascale)
	-- Doesn't need to be set during setup.
	-- Call this on any frame to scale the character and force frame resize (of all frames).
	self.extrascale=extrascale
	self.forceresizeframe=true
end

function TRAININGGROUNDS_WoWCharacter:StrikeOfTheWindlordStagger()
	--override
	--TODO:
end

function TRAININGGROUNDS_WoWCharacter:FistsOfFuryStagger()
	--currently handling this in FoF
	--override
	--TODO: replace with different animation system
end

function TRAININGGROUNDS_WoWCharacter:TouchOfDeathStagger()
	--override
	--TODO: replace with different animation system
end

function TRAININGGROUNDS_WoWCharacter:step(elapsed)
	TRAININGGROUNDS_GameObject.step(self,elapsed)
	
	if(self.combat~=nil)then
		self.combat:step(elapsed,currenttime)
	end	
	
	--TODO: move this check to changeanimation functions
		-- we don't have to check every frame, just when we want to change animations
	if(self.animationendtick~=nil)then
		--print("step",self.environment.currenttime,self.animationendtick)
		if(self.environment.currenttime>=self.animationendtick)then			
			self.animationpriority=0			
			self.animationendtick=nil
		end
		if(self.animationchangeprioritytick~=nil and self.animationnextpriority~=nil)then
			if(self.environment.currenttime>=self.animationchangeprioritytick)then
				self.animationpriority=self.animationnextpriority
				self.animationnextpriority=nil
			end
		end
	end
	
	-- -- x/y movement is handled in GameObject
	-- --TODO: move z movement to gameobject too, currently it's duplicated to both classes
	-- self.z=self.z+self.zspeed*elapsed
	-- self.zspeed=self.zspeed+self.gravity*elapsed
	-- if(self.z<=0) then
		-- if(self.prevz>0) then
			-- self:OnLandOnGround()
		-- end
		-- self.z=0
		-- self.zspeed=0
	-- end
	
	--TODO: move to separate function?
	-- there could be issues with forced movement where prev values are incorrect
	self.prevx=self.x
	self.prevy=self.y
	self.prevz=self.z
end

function TRAININGGROUNDS_WoWCharacter:animate()
	TRAININGGROUNDS_GameObject.animate(self)
	
	self:SetAnimationThisFrame(self.environment.currenttime)
end

function TRAININGGROUNDS_WoWCharacter:draw()
	local camera=self.environment.camera
	
	local adjustedzoom=camera.zoom*self.modelinfo.gameplayscaleratio*self.extrascale
	
	if(camera.zoomchanged==true or self.forceresizeframe==true)then
		self.forceresizeframe=false
		--print("Wowcharacter:draw zoomchanged")
		self:SetFrameSize()	--also calls SetClickFrameSize
		-- we set redrawnameplates here but it can also be set by Resource:SetValue
		self.redrawnameplates=true
		self:CalculateModelOffsets()
		--self:SetClickability()	-- TODO: set this for GameObject too		
		if(self.shadowframe~=nil)then
			-- TODO: adjust shadow size when character jumps
			--print("Resize shadowframe",self.shadowwidth*adjustedzoom)
			self.shadowframe:SetWidth(self.shadowwidth*adjustedzoom)
			self.shadowframe:SetHeight(self.shadowwidth*camera.ystretch*adjustedzoom)
		end		
	end
	
	if(self.redrawnameplates==true)then
		self.redrawnameplates=false
		if(self.combat~=nil and self.combat.nameplate~=nil)then
			--print("ResetPoint ",self.environment.currenttime)
			self.combat.nameplate:ResetPoint()
			self.combat.nameplate:SetAllFrameLevels(self.modelframe.framelevel+1)
		end
	end
	
	local scaledoffsetX=self.modeloffsetX*adjustedzoom
	local scaledoffsetY=self.modeloffsetY*adjustedzoom
	
	self.modelframe:SetPoint("CENTER",self.frame,"CENTER",scaledoffsetX,scaledoffsetY)
	local scrollxoffset,scrollyoffset=camera:GetScrollOffset()
	scrollxoffset=0;scrollyoffset=0 --!!!	--scrolling effect is now handled by scrollframe
	local x=(self.x+scrollxoffset)*camera.zoom
	local y=((self.y+scrollyoffset)*camera.zoom*camera.ystretch)
	local TEMP_screenscale=1	--1.5
	local zoffset=(self.z*camera.zoom*camera.zstretch*TEMP_screenscale)	
	--self.frame:SetPoint("CENTER",self.parentframe,"CENTER",x,y+zoffset)
	self.frame:SetPoint(self.alignment,self.parentframe,camera.objectanchor,x,y+zoffset)

	if(self.shadowframe~=nil)then
		-- TODO: adjust shadow size when character jumps
		--self.shadowframe:SetPoint("CENTER",self.parentframe,"CENTER",x,y)
		self.shadowframe:SetPoint(self.alignment,self.parentframe,camera.objectanchor,x,y)
	end
	
end

function TRAININGGROUNDS_WoWCharacter:changeFrameAnimation(animation)	
	if(animation~=self.currentanimation)then
		--print("TRAININGGROUNDS_WoWCharacter",self,animation,self.currentanimation)
		self.modelframe:SetAnimation(animation);
		self.currentanimation=animation;
	end
end
function TRAININGGROUNDS_WoWCharacter:changeFrameAnimationAndOverride(animation)
	self.modelframe:SetAnimation(animation);
	self.currentanimation=animation;
end

function TRAININGGROUNDS_WoWCharacter:SetMoveVectorByXY(movevectorxx,movevectoryy)
	--TODO: set angle
	self.movevectorxx=movevectorxx
	self.movevectoryy=movevectoryy
end

function TRAININGGROUNDS_WoWCharacter:SetAnimationThisFrame(currenttime)
	local IDLE=TRAININGGROUNDS_PlayerAnimations.PRIORITIES.IDLE
	local MOVEMENT=TRAININGGROUNDS_PlayerAnimations.PRIORITIES.MOVEMENT
	
	--if(currenttime>self.animationendtick)then
	
	if(self.deadingame~=true)then
		local roll=nil
		local fsk=nil
		if(self.combat~=nil)then
			roll=self.combat:GetBuffIfExists(TRAININGGROUNDS_Buff_W7_WindwalkerMonk_Roll)
			fsk=self.combat:GetBuffIfExists(TRAININGGROUNDS_Buff_W7_WindwalkerMonk_FlyingSerpentKick)
		end
		if(fsk~=nil)then
			self:SetAnimationByIndex(702,MOVEMENT)	-- FSK
		elseif(roll~=nil)then			
			self:SetAnimationByIndex(666,MOVEMENT)	-- roll
		elseif(self.z~=0) then
			self:SetAnimationByIndex(38,MOVEMENT)	-- midair
		else
			if(self.movespeed>0.05) then
				if(self.movespeed>2.5)then
					self:SetAnimationByIndex(self.animationindex_superfastrun,MOVEMENT) -- fast run
				elseif(self.movespeed>1.2)then
					self:SetAnimationByIndex(self.animationindex_fastrun,MOVEMENT) -- fast run
				elseif(self.movespeed>0.5) then
					self:SetAnimationByIndex(self.animationindex_run,MOVEMENT)	-- run
				else
					self:SetAnimationByIndex(self.animationindex_walk,MOVEMENT)	-- walk
				end
			else
				--TODO: change idle animation depending on things
				if(currenttime>self.combatstanceendtick)then
					-- if(self.currentanimation~=0)then
						-- print("idle; previously ",self.currentanimation)
					-- end
										
					-- if the player isn't moving, allow IDLE to override MOVEMENT
					if(self.animationpriority==MOVEMENT)then self.animationpriority=IDLE end
					--TODO: option to override movement in the function
					self:SetAnimationByIndex(self.idleanimindex,IDLE)					
				else
					--TODO: self.player:changeFrameAnimation(self.player.combatstanceanimation)
					if(self.animationpriority==MOVEMENT)then self.animationpriority=IDLE end
					self:SetAnimationByIndex(self.combatstanceidleanimindex,IDLE)					
				end
			end
		end
	end
	--else
--		--print("TRAININGGROUNDS_WoWCharacter",self)
	--end
end

function TRAININGGROUNDS_WoWCharacter:changeFacing(targetfacing,elapsed,turnspeed)
	--TODO: not temp
	local TEMP_FACINGCHANGESPEED=10*turnspeed;
	
	local difference=targetfacing-self.currentfacing;
	
	if(difference<-math.pi) then difference=difference+math.pi*2 end
	if(difference>math.pi) then difference=difference-math.pi*2 end
	
	local facingchange=0;
	
	if(difference>0)then facingchange=TEMP_FACINGCHANGESPEED*elapsed end
	if(difference<0)then facingchange=-TEMP_FACINGCHANGESPEED*elapsed end

	if(math.abs(math.abs(difference)-math.pi)<TEMP_FACINGCHANGESPEED*elapsed) then
		if(math.random()>.5)then
			facingchange=-facingchange
		end
	end
	
	local newfacing=self.currentfacing+facingchange
	
	if(math.abs(difference)<TEMP_FACINGCHANGESPEED*elapsed*2) then
		newfacing=targetfacing
	end	
	
	if(newfacing<-math.pi) then newfacing=newfacing+math.pi*2 end
	if(newfacing>math.pi) then newfacing=newfacing-math.pi*2 end
	
	
	self:SetAdjustedFacing(newfacing)
	
end

function TRAININGGROUNDS_WoWCharacter:SetAdjustedFacing(facing)
	self.currentfacing=facing
	local adjustedfacing=facing
	local camera=self.environment.camera
	if(camera~=nil)then
		local xx=math.cos(facing)
		local yy=math.sin(facing)		
		
		--multiplying xx by ystretch because we're using WoWradians
		adjustedfacing=math.atan2(yy,xx*camera.ystretch)
	end
	
	
	self.modelframe:SetFacing(adjustedfacing)

end

function TRAININGGROUNDS_WoWCharacter:AttemptJump()
	if(self.z<=0) then
		self.zspeed=self.jumpspeed
		self.zimpetus=self.jumpimpetus		
		-- if(self.environment.currenttime>self.attackanimationendtick)then
			-- --TODO: split attack animationendtick and nonattack animationendtick
			-- -- for example, we should be able to interrupt endjumpanimation with another jumpanimation
			-- -- (and vice versa, if airtime is decreased)
			-- --TODO: running should be able to interrupt landing animation
			-- self:changeFrameAnimation(self.jumpanimationsequence)
			-- self.attackanimationendtick=self.environment.currenttime+self.jumpanimationduration
		-- end
		self:SetAnimationByName("Jump")
	end

end

function TRAININGGROUNDS_WoWCharacter:OnLandOnGround()
	--if(self.environment.currenttime>self.animationendtick)then
		--!!!
		--self:changeFrameAnimation(self.endjumpanimationsequence)
		--self.attackanimationendtick=self.environment.currenttime+self.endjumpanimationduration
		
		if(self:isa(TRAININGGROUNDS_PlayerCharacter))then
			self:SetAnimationByName("LandOnGround",TRAININGGROUNDS_PlayerAnimations.PRIORITIES.EMOTE,100)
		elseif(self.npcanimations~=nil)then
			if(self.npcanimations["LandOnGround"]~=nil)then
				if(self.npcanimations["LandOnGround"].duration~=nil)then
					self:SetAnimationByIndex(39,TRAININGGROUNDS_PlayerAnimations.PRIORITIES.EMOTE,self.npcanimations["LandOnGround"].duration)
				end
			end
		end
		
		--TODO: this is going to immediately break for NPCs
	--end
	self:BelowGround()
end

function TRAININGGROUNDS_WoWCharacter:BelowGround()
	--TODO: call super?	
	self.z=0
	self.zspeed=0
end




-- if DURATION is nil, animation lasts forever.
-- if PRIORITY2+CHANGEDURATION are nil, animation doesn't change duration.
function TRAININGGROUNDS_WoWCharacter:SetAnimationByIndex(index,priority,duration,override,priority2,changeduration)
	--print("SetAnimationByIndex",priority,self.animationpriority)
	--if(priority>=self.animationpriority)then

		
	if(TRAININGGROUNDS_PlayerAnimations.PriorityOverridesPriority(priority,self.animationpriority)==true)then
		local currenttime=self.environment.currenttime
		self.animationpriority=priority
		if(duration~=nil)then self.animationendtick=currenttime+duration else self.animationendtick=nil end
		self.animationnextpriority=priority2
		if(priority2~=nil and changeduration~=nil)then	self.animationchangeprioritytick=currenttime+changeduration else self.animationchangeprioritytick=nil end
		if(override==true)then			
			self:changeFrameAnimationAndOverride(index)
		else
			self:changeFrameAnimation(index)
		end
	end
end


function TRAININGGROUNDS_WoWCharacter:SetAnimationByName(name,priority2,changeduration)
	--TODO: not all WoWCharacters use PlayerAnimations
	local index,duration,priority = TRAININGGROUNDS_PlayerAnimations.GetDetailsForNamedAnimation(name,self.race,self.sex)
	
	self:SetAnimationByIndex(index,priority,duration,true,priority2,changeduration)
	
	--TODO: not attackanimation	
	--self.attackanimationendtick=self.environment.currenttime+duration
	--self:changeFrameAnimationAndOverride(index)
	
	
	
	
end




-- wowinterface.com/forums/showthread.php?s=50530865d99344176709a23ca736759c&t=48394&page=2
-- do NOT call SetOrientation to change which way the character is facing (use SetFacing instead)
-- call SetOrientation only to change distance and camera height, with yaw==0
function TRAININGGROUNDS_WoWCharacter:SetOrientation(distance, yaw, pitch)
	--if(true) then return end
	
	-- reminder: in order to set custom camera, frame must be Show()ing already
    if self.modelframe:HasCustomCamera() then
		self.modelframe.distance, self.modelframe.yaw, self.modelframe.pitch = distance, yaw, pitch
        local x = distance * math.cos(yaw) * math.cos(pitch)
        local y = distance * math.sin(- yaw) * math.cos(pitch)
        local z = (distance * math.sin(- pitch))		
        self.modelframe:SetCameraPosition(x, y, z)
    end
end

	--self.modelframe:SetDisplayInfo(111665)
	--self.modelframe:SetUnit("player")
	--self.modelframe:SetDisplayInfo(27510)
	
	--self.modelframe:SetModel("SPELLS\\RedRadiationFog.m2")--!!!
	--self.modelframe:SetModel("world\\expansion01\\doodads\\generic\\bloodelf\\powerorb\\bloodelf_powerorb_red_nosound.m2")--!!!
	--self.modelframe:SetModel("World\\Expansion01\\Doodads\\Auchindoun\\Passivedoodads\\Bridge_FX\\Auchindoun_Bridge_FX.mdx")
	
	--self.modelframe:SetModel("World\\Generic\\Human\\Passive Doodads\\Weapons&Armor\\HumanSword01.mdx")
	--self.modelframe:SetModel("World\\Generic\\Human\\Passive Doodads\\Weapons&Armor\\HumanMace02.mdx")
	
	--self.modelframe:SetModel(30606)
	--self.modelframe:SetDisplayInfo(30606)
	--self.modelframe:SetCreature(30606)
	--self.modelframe:SetModel("World\\Expansion01\\Doodads\\Generic\\Ethereal\\HolographicStand\\ET_Holographic_Stand.mdx")
	--self.modelframe:SetModelScale(0.25)--!!!
	
function TRAININGGROUNDS_WoWCharacter:DieInGame(currenttime)	
	self.deadingame=true
	self.combat:OnDie(currenttime)
	self.combat.hp.visibleinnameplate=false
	self.combat:CreateNameplate()
	--print(self.combat.hp.visibleinnameplate)
	buff=TRAININGGROUNDS_Buff_Tutorial_VisualFadeOut.new()
	--print(tick,player)
	buff:setup(self.combat,self.environment.currenttime)
	buff.duration=3000	
	self.expirytime=self.environment.currenttime+buff.duration
	self:SetAnimationByIndex(1,TRAININGGROUNDS_PlayerAnimations.PRIORITIES.DEAD,buff.duration)	
	local player=self.environment.player
	if(player~=nil)then
		self:SetTargetingCircleColor(player)
	end
	
end
	
function TRAININGGROUNDS_WoWCharacter:Cleanup()
	TRAININGGROUNDS_GameObject.Cleanup(self)
	--Parent function will clean up other frames...
	if(self.modelframe~=nil)then
		if(self.modelframe.Cleanup~=nil)then		
			self.modelframe.Cleanup(self.modelframe)	
		end
	end
	
	_TRAININGGROUNDS:tremovebyval(self.environment.wowcharacters,self)
	
end